###########################################
#########      Jordi Molas Gaja     #######
######### Projecte Final de Carrera #######
#########     ETIS - Pla 2001 -     #######
#########      Setembre 2007        #######
###########################################

#Importem els mduls
#--------------------------------
import Blender
from Blender import Mesh, NMesh, Scene, Window, Lamp, Object, Material, Draw, BGL, Camera, Text, Constraint, World
from math import pi, sin, cos, atan, sqrt
from Blender.Scene import Render
from Blender.sys import *

#Imports necessris per a mostrar botons:
from Blender.Draw import *
from Blender.BGL import *

#Imports necessaris per mostrar sortides de teclat per pantalla
import sys, os, struct, string


#***************************
# DEFINIM CLASSES
#***************************

############################################
## --------- CLASSE MATRIU BOCA --------- ##
############################################

class Vector_Triangulacio:
    Quartets=0  #Els quartets sern el nombre de conjunts format per quatre vrtexs.
    Columnes_Plenes=0
    Vector=[0,0,0,0]

    def __init__(self):
        self.Columnes_Plenes=0
        self.Vector=[0,0,0,0]
        self.Quartets=0

    def dump(self):
        print "Columnes Plenes ", self.Columnes_Plenes
        print "Vector ", self.Matriu
        print "Quartets ", self.Quartets
        
        

class Matriu_Boca:
    fila=0
    Matriu_Vertex_Boca=[[0,0,0]]
    
    def __init__(self):
        self.fila=0
        self.Matriu_Vertex_Boca=[[0,0,0]]

    def dump(self):
        print "Fila ", self.fila
        print "Matriu ", self.Matriu_Vertex_Boca
        

    
class Matriu_Graham:
    fila=0
    Matriu_Vertex_Boca=[[0,0,0]]

    def __init__(self):
        self.fila=0
        self.Matriu_Vertex_Boca=[[0,0,0]]

    def dump(self):
        print "Fila ", self.fila
        print "Matriu ",self.Matriu_Vertex_Boca
        

class Matriu_Nova:
    fila=0
    Matriu_Vertex_Boca=[[0,0,0]]

    def __init__(self):
        self.fila=0
        self.Matriu_Vertex_Boca=[[0,0,0]]

    def dump(self):
        print "Fila ", self.fila
        print "Matriu ", self.Matriu_Vertex_Boca


class Matriu_Triangulacio:
    fila=0
    Matriu_Vertex_Boca=[[0,0,0,0]]
##    posicio=[[0]] #Aquesta posicio ens serveix per fer la triangulaci (uni entre vertexs)

    def __init__(self):
        self.fila=0
        self.Matriu_Vertex_Boca=[[0,0,0,0]]
##        self.posicio=[[0]]

    def dump(self):
        print "Fila ", self.fila
        print "Matriu ", self.Matriu_Vertex_Boca
##        print "Posicio ",self.posicio

class Matriu_Temporal:
    fila=0
    Matriu_Vertex_Boca=[[0,0,0]]

    def __init__(self):
        self.fila=0
        self.Matriu_Vertex_Boca=[[0,0,0]]

    def dump(self):
        print "Fila ", self.fila
        print "Matriu ",self.Matriu_Vertex_Boca        

class Triangle:
    posicio=0
    vertexs=[0,0,0]
    def __init__(self):
        self.posicio=0
        self.vertexs=[0,0,0]
    def dump(self):
        print "Posicio ", self.posicio
        print "Vertexs ", self.vertexs



        
        
############################################
## -------------------------------------- ##
############################################

#***************************
# DEFINIM FUNCIONS
#***************************

#Aquesta funci ens elimina els possibles espais en blanc o salts de carro que podem
#llegir a la lnia del nostre fitxer.
def Tractar_linia(linea):
    nova_linia = ""
    for i in range(len(linea)):
        #if (linea[i] == " "):
            #print "hem trobat un espai"
        #elif (linea[i] == '\n'):
            #print "hem trobat un salt de carro"
        if ((linea[i] != " ") and (linea[i] != '\n')):
            #print "hem trobat: ",linea[i]
            nova_linia=nova_linia+linea[i] #Fa una concatenaci de lletres

    return (nova_linia)

#Aquesta funci llegeix les dues lnies del fitxer
#La primera lnea s el codi i la segona lnia el  "valor"
def Llegim_Parell_linies(filename):

    global GroupCode
    global linea
    
    file = filename
    GroupCode = file.readline()
    GroupCode = Tractar_linia(GroupCode)#utilitzem aquesta funci per treure'n la cadena exacte (sense espais)
    linea = file.readline()
    linea = Tractar_linia(linea)



#############################################
########### MXIMS -- -- MNIMS #############
#############################################

def min(a,b):
    if a < b:
        return a
    else:
        return b

def max(a,b):
    if a > b:
        return a
    else:
        return b


##############################################
#######     FUNCIONS PER MATRIUS      ########
##############################################

#Fem una copia de la matriu_original
def Copiar_Matrius(matriu_original, matriu_copia):
    #Recordem que el for no arriba mai al final del range
    for i in range(0,matriu_original.fila):
        Crear_Matriu_Boca(matriu_copia, matriu_original.Matriu_Vertex_Boca[i][0], matriu_original.Matriu_Vertex_Boca[i][1], matriu_original.Matriu_Vertex_Boca[i][2])
    
        
#Deixem la matriu a zero, com si l'hagussim esborrat.
#Noms cont zeros i fila=0
def Natejar_Matriu(matriu):
    for i in range(0,matriu.fila):
        matriu.Matriu_Vertex_Boca[i][0]=0
        matriu.Matriu_Vertex_Boca[i][1]=0
        matriu.Matriu_Vertex_Boca[i][2]=0
    matriu.fila=0

############################################
############# GRAHAM SCAN ##################
############################################
#def SWAP(t,x,y):
#    t=x
#    x=y
#    y=t
#    print "x: ", x
#    print "y: ", y


#Aquesta funci serveix per eliminar l'ltim element de la matriu.
def Eliminar_Ultim_Vertex(matriu):
    i=matriu.fila-1
    matriu.Matriu_Vertex_Boca[i][0]=0
    matriu.Matriu_Vertex_Boca[i][1]=0
    matriu.Matriu_Vertex_Boca[i][1]=0
    matriu.fila=matriu.fila-1


#Aquesta funci Area2 va junt amb la funci "Graham_Scan"
#Realitza el producte vectorial
def Area2(p1,p2,p3):
    return ((p2[0]-p1[0])*(p3[1]-p1[1]) - (p3[0]-p1[0])*(p2[1]-p1[1]))

#Aquesta funci Esquerra va junt amb la funci "Graham_Scan"
def Esquerra(p1,p2,p3):
##    print "Area2: ",Area2(p1,p2,p3)
    return (Area2(p1,p2,p3) > 0)


#Find Lowest finds the rightmost lowest point and swapps with 0-th.
#The lowest point has the min y-coord, and amongst those, the max
# x-coord: so it is rightmost among the lowest.
def FindLowest2(matriu):
    m=0 #Index of lowest so far.
    for i in range (1,matriu.fila):
        if ((matriu.Matriu_Vertex_Boca[i][1] < matriu.Matriu_Vertex_Boca[m][1]) or ((matriu.Matriu_Vertex_Boca[i][1] == matriu.Matriu_Vertex_Boca[m][1]) and (matriu.Matriu_Vertex_Boca[i][0] > matriu.Matriu_Vertex_Boca[m][0]))):
            m = i
##    print "Swapping ",m," with 0\n"
    Swap(0,m,matriu); #Swap P[0] and P[m]
    

#Aquesta funci AreaTriangulo2 va junt amb la funci "Graham_Scan".
#Si aquesta rea ens retorna un valor negatiu vol dir que haurem de descartar el punt candidat a formar
# part del "convex hull"
#p1 s el punt que ja forma part del "convex hull"
#p2 s el punt candidat possible
#p3 s el punt candidat possible si p2 s descartat.
def AreaTriangulo2(p1,p2,p3):
##    print "AreaTriangulo2= "
    print (p1[0]*p2[1] - p1[1]*p2[0] + p2[0]*p3[1] - p2[1]*p3[0] + p3[0]*p1[1] - p3[1]*p1[0])
    return(p1[0]*p2[1] - p1[1]*p2[0] + p2[0]*p3[1] - p2[1]*p3[0] + p3[0]*p1[1] - p3[1]*p1[0])


#Retorna cert o fals si l'rea que formen els 3 punts s positiu o negatiu, respectivament.
def Izquierda(p1,p2,p3):
    return (AreaTriangulo2(p1,p2,p3)>0)


def isLeft(P0,P1,P2):
    return ((P1[0]-P0[0])*(P2[1]-P0[1])-(P2[0]-P0[0])*(P1[1]-P0[1]))

def Cross_Product(P1,P2,P3):
    return ((P2[0] - P1[0]) * (P3[1] - P1[1]) - (P3[0] - P1[0])*(P2[1] - P1[1]))                           


#Ja tenim l'element ms petit a la posici 0 de la matriu
#Ja tenim la matriu vella ordenada segons la tangent (angle).
#FUNCIONA MOLT B!!! NO PENSO FER-HI MS CANVIS.
def Graham_Scan (matriu_vella, matriu_nova):
    Crear_Matriu_Boca(matriu_nova, matriu_vella.Matriu_Vertex_Boca[0][0], matriu_vella.Matriu_Vertex_Boca[0][1], matriu_vella.Matriu_Vertex_Boca[0][2])
    Crear_Matriu_Boca(matriu_nova, matriu_vella.Matriu_Vertex_Boca[1][0], matriu_vella.Matriu_Vertex_Boca[1][1], matriu_vella.Matriu_Vertex_Boca[1][2])
    i=2
    
    while (i < matriu_vella.fila):

        o = Cross_Product(matriu_nova.Matriu_Vertex_Boca[matriu_nova.fila-2],matriu_nova.Matriu_Vertex_Boca[matriu_nova.fila-1], matriu_vella.Matriu_Vertex_Boca[i])
            
        if (o > 0):
            Crear_Matriu_Boca(matriu_nova, matriu_vella.Matriu_Vertex_Boca[i][0], matriu_vella.Matriu_Vertex_Boca[i][1], matriu_vella.Matriu_Vertex_Boca[i][2])
            #Ara tinc ficat a dins la matriu nova el punt 0,1 i 2 per el 2 no m'interessa tenir-lo; l'hem de canviar pel 6
            #Ara tinc 3 elements nous a dins la matriu_nova
            #comprovem la o amb el punt 3
            j=i
            while ((o > 0) and (j < matriu_vella.fila)):
            #while (o > 0):
                
                o = Cross_Product(matriu_nova.Matriu_Vertex_Boca[matriu_nova.fila-2], matriu_nova.Matriu_Vertex_Boca[matriu_nova.fila-1], matriu_vella.Matriu_Vertex_Boca[j])
                j = j + 1
        elif (o < 0):
            Eliminar_Ultim_Vertex(matriu_nova)
            Crear_Matriu_Boca(matriu_nova, matriu_vella.Matriu_Vertex_Boca[i][0], matriu_vella.Matriu_Vertex_Boca[i][1], matriu_vella.Matriu_Vertex_Boca[i][2])

        i = i+1

    #Ara sortim del bucle i per aix hem de fer la ltima comprovaci quan noms queda un sol element
    #a la matriu vella per comprovar.

    o = Cross_Product(matriu_nova.Matriu_Vertex_Boca[matriu_nova.fila-2],matriu_nova.Matriu_Vertex_Boca[matriu_nova.fila-1], matriu_vella.Matriu_Vertex_Boca[matriu_vella.fila-1])
            
    if (o > 0):
        Crear_Matriu_Boca(matriu_nova, matriu_vella.Matriu_Vertex_Boca[i][0], matriu_vella.Matriu_Vertex_Boca[i][1], matriu_vella.Matriu_Vertex_Boca[i][2])
        #Ara tinc ficat a dins la matriu nova el punt 0,1 i 2 per el 2 no m'interessa tenir-lo; l'hem de canviar pel 6
        #Ara tinc 3 elements nous a dins la matriu_nova
        #comprovem la o amb el punt 3
            
    elif (o < 0):
        Eliminar_Ultim_Vertex(matriu_nova)
        Crear_Matriu_Boca(matriu_nova, matriu_vella.Matriu_Vertex_Boca[matriu_vella.fila-1][0], matriu_vella.Matriu_Vertex_Boca[matriu_vella.fila-1][1], matriu_vella.Matriu_Vertex_Boca[matriu_vella.fila-1][2])
    
    
#Ja tenim l'element ms petit a la posici 0 de la matriu
#Ja tenim la matriu vella ordenada segons la tangent (angle).
def Graham_Scan_FUNCIONA(matriu_vella, matriu_nova):
    Crear_Matriu_Boca(matriu_nova, matriu_vella.Matriu_Vertex_Boca[0][0], matriu_vella.Matriu_Vertex_Boca[0][1], matriu_vella.Matriu_Vertex_Boca[0][2])
    Crear_Matriu_Boca(matriu_nova, matriu_vella.Matriu_Vertex_Boca[1][0], matriu_vella.Matriu_Vertex_Boca[1][1], matriu_vella.Matriu_Vertex_Boca[1][2])

    i=2
    
    o = Cross_Product(matriu_nova.Matriu_Vertex_Boca[matriu_nova.fila-2],matriu_nova.Matriu_Vertex_Boca[matriu_nova.fila-1], matriu_vella.Matriu_Vertex_Boca[i])
##    print 'o2 = ',o #dona o>0 (amb el primer o)

    if (o > 0):
        Crear_Matriu_Boca(matriu_nova, matriu_vella.Matriu_Vertex_Boca[i][0], matriu_vella.Matriu_Vertex_Boca[i][1], matriu_vella.Matriu_Vertex_Boca[i][2])
        #Ara tinc ficat a dins la matriu nova el punt 0,1 i 2 per el 2 no m'interessa tenir-lo; l'hem de canviar pel 6
        #Ara tinc 3 elements nous a dins la matriu_nova
        #comprovem la o amb el punt 3
        o = Cross_Product(matriu_nova.Matriu_Vertex_Boca[matriu_nova.fila-2], matriu_nova.Matriu_Vertex_Boca[matriu_nova.fila-1], matriu_vella.Matriu_Vertex_Boca[i+1])
        j=1;
        while (o > 0):
            j=j+1
            o = Cross_Product(matriu_nova.Matriu_Vertex_Boca[matriu_nova.fila-2], matriu_nova.Matriu_Vertex_Boca[matriu_nova.fila-1], matriu_vella.Matriu_Vertex_Boca[i+j])
##            print 'o',j+i,' = ',o
    if (o < 0):
        Eliminar_Ultim_Vertex(matriu_nova)
##        print matriu_vella.Matriu_Vertex_Boca[j+i][0]
        Crear_Matriu_Boca(matriu_nova, matriu_vella.Matriu_Vertex_Boca[j+i][0], matriu_vella.Matriu_Vertex_Boca[j+i][1], matriu_vella.Matriu_Vertex_Boca[j+i][2])
        #==== FINS AQUI VA B =====#
        
    o = Cross_Product(matriu_nova.Matriu_Vertex_Boca[matriu_nova.fila-2], matriu_nova.Matriu_Vertex_Boca[matriu_nova.fila-1], matriu_vella.Matriu_Vertex_Boca[j+i+1])
##    print 'o',j+i+1,' = ',o
    if (o < 0):
        Eliminar_Ultim_Vertex(matriu_nova)
##        print matriu_vella.Matriu_Vertex_Boca[j+i+1][0]
        Crear_Matriu_Boca(matriu_nova, matriu_vella.Matriu_Vertex_Boca[j+i+1][0], matriu_vella.Matriu_Vertex_Boca[j+i+1][1], matriu_vella.Matriu_Vertex_Boca[j+i+1][2])
    o = Cross_Product(matriu_nova.Matriu_Vertex_Boca[matriu_nova.fila-2], matriu_nova.Matriu_Vertex_Boca[matriu_nova.fila-1], matriu_vella.Matriu_Vertex_Boca[j+i+2])
##    print 'o',j+i+1,' = ',o
     
    #Ara em sembla que hauria de repetir el bucle while (o>0):
    


#Tant la Ymax, Ymin, Xmax com la Xmin utilitzarem
#la matriu resultant de Graham Scan.
def Ymax(matriu):

    #com que volem trobar la y comprovem la columna 1:
    var = matriu.Matriu_Vertex_Boca[0][1]
    for i in range (1, matriu.fila):
        var = max(var, matriu.Matriu_Vertex_Boca[i][1])

    return(var)

def Ymin(matriu):

    #Com que volem trobar la y comprovem la columna 1:
    var = matriu.Matriu_Vertex_Boca[0][1]
    for i in range (1, matriu.fila):
        var = min(var, matriu.Matriu_Vertex_Boca[i][1])

    return (var)
    
def Xmin(matriu):

    #Com que volem trobar la x comprovem la columna 0:
    var = matriu.Matriu_Vertex_Boca[0][0]
    for i in range (1, matriu.fila):
        var = min(var, matriu.Matriu_Vertex_Boca[i][0])

    return (var)        

def Xmax(matriu):

    #Com que volem trobar la x comprovem la columna 0:
    var = matriu.Matriu_Vertex_Boca[0][0]
    for i in range (1, matriu.fila):
        var = max(var, matriu.Matriu_Vertex_Boca[i][0])

    return (var)    


#P1 s el primer vertex que forma la lnia
#P2 s el segon vrtex que forma la lnia
#P3 s el vrtex que volem saber si tirant una lnia vertical es creua amb la lnia formada
# per P1 i P2
#Recordar que per calcular la lnia es fa: vrtexfinal - vrtexinicial, s a dir, P2 - P1
def InterseccioVertical(P1,P2,P3):
    #Com que P1, P2 i P3 sn vectors, tindran les seves components x, y i z
    #P1[x,y,z], P2[x,y,z], P3[x,y,z]
    if (P1[0]==P2[0]): return ("False")
    else:
        t=(P3[0]-P1[0])/(P2[0]-P1[0])
        if ((t<0) or (t>1)): return ("False")
        else:
            s = P1[1] * (1-t) + P2[1] * t - P3[1]
            if (s>=0): return ("False")
            else: return ("True")


#La matriu que li passem s la matriu graham Scan
def CrearPuntsInteriors2(matriu):
    #La variable comptador ens indicar quantes vegades intersecta el vertex candidat quan llencem una recta vertical.
    comptador=0

    #La variable pas s l'increment que fa el bucle del for
    # per defecte anir a pas 1.
    #necessitem una matriu nova per passar-hi els punts interiors
    matriu_nova = Matriu_Nova()
    pas= 20
    maximaY = int(Ymax(matriu))
    maximaX = int(Xmax(matriu))
    minimaY = int(Ymin(matriu))
    minimaX = int(Xmin(matriu))
   
    #limitem la nostra rea segons un quadrat (els punts sern vectors)

    #Limit_Esq_Sota         part esquerra inferior
    #Limit_Esq_Sobre        part esquerra superior
    #Limit_Dreta_Sota       part dreta inferior
    #Limit_Dreta_Sobre      part dreta superior

    Limit_Esq_Sota= [minimaX, minimaY, 0]
    Limit_Esq_Sobre = [minimaX, maximaY, 0]
    Limit_Dreta_Sota = [maximaX, minimaY, 0]
    Limit_Dreta_Sobre = [maximaX, maximaY, 0]

    #Els lmits em serviaran per saber si els punts es troben a dins o
    # a fora de la nostra boca, juntament amb la funci Cross_Product.
    for y in range(minimaY, maximaY, pas):#podrem ajustar ms i fer maximaY+pas a dins del for
        for x in range(minimaX, maximaX, pas):#podrem ajustar ms i fer maximaX+pas a dins del for
            vector = [x,y,0] #creem un vector amb coordenades x, y i z (z=0)
            #deixem l'ultim element de la matriu per comprovar-ne la recta
            #haurem de comprovar aquesta ltima recta de la matriu quan sortim del bucle.
            for i in range (0, matriu.fila-1):
                if (InterseccioVertical(matriu.Matriu_Vertex_Boca[i],matriu.Matriu_Vertex_Boca[i+1],vector)=="True"):
                    comptador=comptador+1
            #quan hem sortit del "for" ens falta comprovar la ltima recta de la matriu
            #Aquesta ltima recta es formar amb l'ltim element de la matriu i el primer element de la matriu.
            if (InterseccioVertical(matriu.Matriu_Vertex_Boca[0],matriu.Matriu_Vertex_Boca[matriu.fila-1],vector)=="True"):
                comptador=comptador+1
            #Ara hem de mirar si el comptador s parell.
            #Si el comptador s parell voldr dir que el vertex candidat haur intersectat 2 vegades(per exemple),
            #aix voldr dir que es troba a fora la nostra boca i per tant no l'haurem d'insertar.
            #En cas contrari l'haurem d'insertar perqu el vrtex es trobar a dins de la boca.
            if ((comptador % 2)==0):
                print "El vector ",vector," NO pertany a la boca."
            else:
##                print "El vector ",vector," SI pertany a la boca."
                #vol dir que el vertex es troba a la part interior de la nostra boca i per tant
                #l'haurem d'afegir a la nostra matriu
                if (Existeix_Vertex_Boca(matriu,vector[0],vector[1],vector[2])=="False"):
                    #si ens retorna fals vol dir que no existeix aquest vector a la nostra matriu i
                    #per tant l'haurem d'afegir.
                 
                    Crear_Matriu_Boca(matriu_nova,vector[0],vector[1],vector[2])
                    #Hem de dibuixar aquest vrtex al nostre polgon
               #     vertex = NMesh.Vert(vector[0],vector[1],vector[2])
                    #Afegim el vertex que hem creat al nostre polgon
               #     poligon.verts.append(vertex)
##                    print "Insertarem el vector"


                
            #POSEM EL COMPTADOR A ZERO ALTRA VEGADA I JA PODEM TORNAR A COMENAR
            comptador=0
    #Ara hem de passar els vertexs que hem insertat a la nostra matriu original
   
    Natejar_Matriu(matriu)
    Copiar_Matrius(matriu_nova,matriu)

##############################################################
##############################################################
#################     TRIANGULACI      ######################
##############################################################
##############################################################

#Aquest funci "Hi_Ha_Uns_Matriu(matriu) ens diu si en la matriu [0,0,0,0] existeix algun "1"
#En cas contrari podrem descartar els vertexs. Ens reotornar "0", "1", "2", "3" o "4".
def Hi_Ha_Uns_Vector(vector):

    #Iniciem la variable NombreUns a zero. Aquesta ens dir el nmero de uns que cont la matriu.
    NombreUns=0
    if (vector[0]==1): NombreUns=NombreUns+1
    if (vector[1]==1): NombreUns=NombreUns+1
    if (vector[2]==1): NombreUns=NombreUns+1
    if (vector[3]==1): NombreUns=NombreUns+1

    return(NombreUns)    
    
#Ens retorna cert o fals depenent de si existeix intersecci vertical.
#Retorna cert si "s" i "t" es troben entre 0 i 1
#Els punts que li passem a la funci sn vrtexs amb component x,y,z.
#punt1,2,3,4 sn els vrtexs que formen el quadrat per fer la triangulaci.
#Per facilitar-ho entrem noms els punts necessaris (punta1,punta2,contorn1,contorn2)
#contorn1,2 sn els vrtexs que formen el contorn de la boca
def HiHa_InterVertical(punta1,punta2,contorn1,contorn2):
    #Haurem de passar-li a1 i a3
    #Haurem de passar-li a2 i a4
    #Calculem el valor de "s"
    if (contorn2[0] - contorn1[0] <> 0):
        s = round(float((punta1[0] - contorn1[0]) / (contorn2[0] - contorn1[0])),4)
    else: return ("False")
    
    #Calculem el valor de "t"
    if (punta2[1]-punta1[1]<>0):
        t = round(float((contorn1[1] - punta1[1] + (s*(contorn2[1] - contorn1[1]))) / (punta2[1] - punta1[1])),4)
    else: return ("False")
##    print "intervertical:",punta1,punta2," s: ",s," t: ",t
    if (s>=0 and s<=1 and t>=0 and t<=1):
        return (t)
    else:
        return("False")


#Ens retorna cert o fals depenent de si existeix intersecci horitzontal.
#Retorna cert si "s" i "t" es troben entre 0 i 1
#Els punts que li passem a la funci sn vrtexs amb component x,y,z.
#punt1,2,3,4 sn els vrtexs que formen el quadrat per fer la triangulaci.
#Per facilitar-ho entrem noms els punts necessaris (punta1,punta2,contorn1,contorn2)
#contorn1,2 sn els vrtexs que formen el contorn de la boca
#Aquesta funci s igual que HiHa_InterVertical per canviaran les parelles de punts que hi entrem
#Els punts formaran una lnia horitzontal.
def HiHa_InterHoritzontal(punta1,punta2,contorn1,contorn2):
    #Haurem de passar-li a1 i a2
    #Haurem de passar-li a3 i a4
    #Calculem el valor de "s"
    if (contorn2[1] - contorn1[1] <> 0):
        s = round(float((punta1[1] - contorn1[1]) / (contorn2[1] - contorn1[1])),4)
    else: return("False")
        
##    print "interhoritzontal:",punta1,punta2
    #Calculem el valor de "t"
    if (punta2[0] - punta1[0] <> 0):
        t = round(float((contorn1[0] - punta1[0] + (s*(contorn2[0] - contorn1[0]))) / (punta2[0] - punta1[0])),4)
    else: return ("False")
        
    
    if (s>=0 and s<=1 and t>=0 and t<=1):
        return (t)
    else:
        return("False")


#Els punt1,2,3,4 sn els vrtexs que formen el quadrat per a fer la triangulaci
#La matriu_contorn cont els vrtexs que formen el contorn de la boca del reflector
#Li passem la matriu perqu haurem de comprovar tots els parells de vrtexs, des del primer fins a l'ltim.
#A dins d'aquesta funci hauran de sortir els punts amb les seves components correctes per tal que es trobin situats
#dins de la boca.
#Tamb li passem la matriu_intern que cont els vrtexs que es troben a l'interior de la boca.
#La matriu "matriunova" s de la classe "Punts_Triangulacio"
#La "posicio" ens serveix per identificar el vrtexs en la posicio que li partocaria en la matriu original m x m (La triangulaci)
def Interseccions(punt1,punt2,punt3,punt4,matriu_contorn, matriu_intern,matriunova, area, Trident, Llista_Triangles):
    #Aquestes dues variables son vrtexs que formen el contorn i ens serveixen per
    #mirar les interseccions.
    b1=[0,0,0]
    b2=[0,0,0]

    posicio=0  #Aquesta posicio s el nombre que ens retorna la funci "Buscar_Posicio()"
##    print "Posicio Interseccions: ",posicio
    for i in range (0,matriu_contorn.fila-1):
        b1=matriu_contorn.Matriu_Vertex_Boca[i]
        b2=matriu_contorn.Matriu_Vertex_Boca[i+1]
##        print "b1: ",b1,"b2: ",b2
        #### - - - -Cas en qu tots els punts es troben a l'interior de la boca- - - - ####
        if (Hi_Ha_Uns_Vector(area)==4):
            if ((Existeix_Vertex_Boca(matriu_intern,punt1[0],punt1[1],punt1[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt1[0],punt1[1],punt1[2])=="False")):
                Crear_Matriu_Boca(matriunova,punt1[0],punt1[1],punt1[2])
                
            if ((Existeix_Vertex_Boca(matriu_intern,punt2[0],punt2[1],punt2[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt2[0],punt2[1],punt2[2])=="False")):
                Crear_Matriu_Boca(matriunova,punt2[0],punt2[1],punt2[2])
                
                
            if ((Existeix_Vertex_Boca(matriu_intern,punt3[0],punt3[1],punt3[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt3[0],punt3[1],punt3[2])=="False")):
                #Entrarem el punt3 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                Crear_Matriu_Boca(matriunova,punt3[0],punt3[1],punt3[2])
                
            if ((Existeix_Vertex_Boca(matriu_intern,punt4[0],punt4[1],punt4[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt4[0],punt4[1],punt4[2])=="False")):
                #Entrarem el punt4 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                Crear_Matriu_Boca(matriunova,punt4[0],punt4[1],punt4[2])
                
                
        #### - - - -Cas en qu 3 vectors es troben a l'interior de la boca- - - - - - ####
        if (Hi_Ha_Uns_Vector(area)==3):
            ### Cas [0,1,1,1] ###
            if (area==[0,1,1,1]):
                interseccio=0
                
                if (HiHa_InterVertical(punt1,punt3,b1,b2)<>"False"):
                    #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                    #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                    #el punt d'intersecci de les dues rectes.
                    t=HiHa_InterVertical(punt1,punt3,b1,b2)
                    a_int_x= punt1[0] - punt1[0]*t + punt3[0]*t
                    a_int_y= punt1[1] - punt1[1]*t + punt3[1]*t
                    punt_inter1=[a_int_x,a_int_y,0]
                    puntvertical=punt_inter1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if (Existeix_Vertex_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])== "False"):
                        Crear_Matriu_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])
                    interseccio=1
                        
                if (HiHa_InterHoritzontal(punt1,punt2,b1,b2)<>"False"):                    t = HiHa_InterHoritzontal(punt1,punt2,b1,b2)
                    a_int_x = punt1[0] - punt1[0]*t + punt2[0]*t
                    a_int_y = punt1[1] - punt1[1]*t + punt2[1]*t
                    punt_inter1=[a_int_x,a_int_y,0]
                    punthoritzontal=punt_inter1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if (Existeix_Vertex_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])=="False"):
                        Crear_Matriu_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])
                    interseccio=1
                                                    
                #En aquest punt ja haurem insertat les dues interseccions
                #Ara hem d'insertar el punt 2
                if ((Existeix_Vertex_Boca(matriu_intern,punt2[0],punt2[1],punt2[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt2[0],punt2[1],punt2[2])=="False") and (interseccio==1)):
                    Crear_Matriu_Boca(matriunova,punt2[0],punt2[1],punt2[2])
                                                 
                    
                if ((Existeix_Vertex_Boca(matriu_intern,punt3[0],punt3[1],punt3[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt3[0],punt3[1],punt3[2])=="False") and (interseccio==1)):
                    #Entrarem el punt3 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                    Crear_Matriu_Boca(matriunova,punt3[0],punt3[1],punt3[2])
                                                                            
                if ((Existeix_Vertex_Boca(matriu_intern,punt4[0],punt4[1],punt4[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt4[0],punt4[1],punt4[2])=="False") and (interseccio==1)):
                    #Entrarem el punt4 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                    Crear_Matriu_Boca(matriunova,punt4[0],punt4[1],punt4[2])
                                        
                                       
            ### CAS [1,0,1,1] ###
            if (area==[1,0,1,1]):
                interseccio=0
                if ((Existeix_Vertex_Boca(matriu_intern,punt1[0],punt1[1],punt1[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt1[0],punt1[1],punt1[2])=="False")):
                    Crear_Matriu_Boca(matriunova,punt1[0],punt1[1],punt1[2])
                                                               
                    
                if (HiHa_InterHoritzontal(punt1,punt2,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_2"
                    t = HiHa_InterHoritzontal(punt1,punt2,b1,b2)
                    a_int_x = punt1[0] - punt1[0]*t + punt2[0]*t
                    a_int_y = punt1[1] - punt1[1]*t + punt2[1]*t
                    punt_inter2=[a_int_x,a_int_y,0]
                    punthoritzontal=punt_inter2
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if (Existeix_Vertex_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])=="False"):
                        Crear_Matriu_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])
                if (HiHa_InterVertical(punt2,punt4,b1,b2)<>"False"):
##                    print "HiHaInterVertical_2"
                    t = HiHa_InterVertical(punt2,punt4,b1,b2)
                    a_int_x = punt2[0] - punt2[0]*t + punt4[0]*t
                    a_int_y = punt2[1] - punt2[1]*t + punt4[1]*t
                    punt_inter2=[a_int_x,a_int_y,0]
                    puntvertical=punt_inter2
                    interseccio=1
                    #ja podem insertar aquest "punt_inter2" a la "matriunova"
                    if (Existeix_Vertex_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])=="False"):
                        Crear_Matriu_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])
                        
                if ((Existeix_Vertex_Boca(matriu_intern,punt3[0],punt3[1],punt3[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt3[0],punt3[1],punt3[2])=="False") and interseccio==1):
                    #Entrarem el punt3 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                    Crear_Matriu_Boca(matriunova,punt3[0],punt3[1],punt3[2])
                   
                if ((Existeix_Vertex_Boca(matriu_intern,punt4[0],punt4[1],punt4[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt4[0],punt4[1],punt4[2])=="False") and interseccio==1):
                    #Entrarem el punt4 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                    Crear_Matriu_Boca(matriunova,punt4[0],punt4[1],punt4[2])
                    
            ### CAS [1,1,0,1] ###
            if (area==[1,1,0,1]):
                interseccio=0
                if ((Existeix_Vertex_Boca(matriu_intern,punt1[0],punt1[1],punt1[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt1[0],punt1[1],punt1[2])=="False")):
                    Crear_Matriu_Boca(matriunova,punt1[0],punt1[1],punt1[2])
                                        
                if ((Existeix_Vertex_Boca(matriu_intern,punt2[0],punt2[1],punt2[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt2[0],punt2[1],punt2[2])=="False")):
                    Crear_Matriu_Boca(matriunova,punt2[0],punt2[1],punt2[2])
                                       
                if (HiHa_InterVertical(punt1,punt3,b1,b2)<>"False"):
##                    print "HiHaInterVertical_3"
                    #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                    #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                    #el punt d'intersecci de les dues rectes.
                    t=HiHa_InterVertical(punt1,punt3,b1,b2)
                    a_int_x= punt1[0] - punt1[0]*t + punt3[0]*t
                    a_int_y= punt1[1] - punt1[1]*t + punt3[1]*t
                    punt_inter3=[a_int_x,a_int_y,0]
                    puntvertical=punt_inter3
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if ((Existeix_Vertex_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])== "False")):
                        Crear_Matriu_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])
                        
                if (HiHa_InterHoritzontal(punt3,punt4,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_3"
                    t = HiHa_InterHoritzontal(punt3,punt4,b1,b2)
                    a_int_x = punt3[0] - punt3[0]*t + punt4[0]*t
                    a_int_y = punt3[1] - punt3[1]*t + punt4[1]*t
                    punt_inter3=[a_int_x,a_int_y,0]
                    punthoritzontal=punt_inter3
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if (Existeix_Vertex_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])=="False"):
                        Crear_Matriu_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])
                        
                if ((Existeix_Vertex_Boca(matriu_intern,punt4[0],punt4[1],punt4[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt4[0],punt4[1],punt4[2])=="False") and interseccio==1):
                    #Entrarem el punt4 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                    Crear_Matriu_Boca(matriunova,punt4[0],punt4[1],punt4[2])
                    
                    
            ### CAS [1,1,1,0] ###
            if (area==[1,1,1,0]):
                interseccio=0
                if ((Existeix_Vertex_Boca(matriu_intern,punt1[0],punt1[1],punt1[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt1[0],punt1[1],punt1[2])=="False")):
                    Crear_Matriu_Boca(matriunova,punt1[0],punt1[1],punt1[2])
                                        
                if ((Existeix_Vertex_Boca(matriu_intern,punt2[0],punt2[1],punt2[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt2[0],punt2[1],punt2[2])=="False")):
                    Crear_Matriu_Boca(matriunova,punt2[0],punt2[1],punt2[2])
                                        
                if ((Existeix_Vertex_Boca(matriu_intern,punt3[0],punt3[1],punt3[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt3[0],punt3[1],punt3[2])=="False")):
                    #Entrarem el punt3 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                    Crear_Matriu_Boca(matriunova,punt3[0],punt3[1],punt3[2])
                    
                if (HiHa_InterHoritzontal(punt3,punt4,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_4"
                    t = HiHa_InterHoritzontal(punt3,punt4,b1,b2)
                    a_int_x = punt3[0] - punt3[0]*t + punt4[0]*t
                    a_int_y = punt3[1] - punt3[1]*t + punt4[1]*t
                    punt_inter4=[a_int_x,a_int_y,0]
                    punthoritzontal=punt_inter4
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if ((Existeix_Vertex_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])=="False")):
                        Crear_Matriu_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])
                        
                if (HiHa_InterVertical(punt2,punt4,b1,b2)<>"False"):
##                    print "HiHaInterVertical_4"
                    #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                    #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                    #el punt d'intersecci de les dues rectes.
                    t=HiHa_InterVertical(punt2,punt4,b1,b2)
                    a_int_x= punt2[0] - punt2[0]*t + punt4[0]*t
                    a_int_y= punt2[1] - punt2[1]*t + punt4[1]*t
                    punt_inter4=[a_int_x,a_int_y,0]
                    puntvertical=punt_inter4
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if ((Existeix_Vertex_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])== "False")):
                        Crear_Matriu_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])
                        
                               
        #### - - - -Cas en qu 2 vectors es troben a l'interior de la boca - - - - - - ####
        if (Hi_Ha_Uns_Vector(area)==2):
            ### Cas [0,0,1,1] ###
            if (area==[0,0,1,1]):
                interseccio=0
                if (HiHa_InterVertical(punt1,punt3,b1,b2)<>"False"):
##                    print "HiHaInterVertical_1"
                    #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                    #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                    #el punt d'intersecci de les dues rectes.
                    t=HiHa_InterVertical(punt1,punt3,b1,b2)
                    a_int_x= punt1[0] - punt1[0]*t + punt3[0]*t
                    a_int_y= punt1[1] - punt1[1]*t + punt3[1]*t
                    punt_inter1=[a_int_x,a_int_y,0]
                    puntvertical1=punt_inter1
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if (Existeix_Vertex_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])== "False"):
                        Crear_Matriu_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])
                if (HiHa_InterVertical(punt2,punt4,b1,b2)<>"False"):
##                    print "HiHaInterVertical_2"
                    #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                    #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                    #el punt d'intersecci de les dues rectes.
                    t=HiHa_InterVertical(punt2,punt4,b1,b2)
                    a_int_x= punt2[0] - punt2[0]*t + punt4[0]*t
                    a_int_y= punt2[1] - punt2[1]*t + punt4[1]*t
                    punt_inter2=[a_int_x,a_int_y,0]
                    puntvertical2=punt_inter2
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if (Existeix_Vertex_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])== "False"):
                        Crear_Matriu_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])
                        
                if ((Existeix_Vertex_Boca(matriu_intern,punt3[0],punt3[1],punt3[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt3[0],punt3[1],punt3[2])=="False") and interseccio==1):
                    #Entrarem el punt3 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                    Crear_Matriu_Boca(matriunova,punt3[0],punt3[1],punt3[2])
                    
                if ((Existeix_Vertex_Boca(matriu_intern,punt4[0],punt4[1],punt4[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt4[0],punt4[1],punt4[2])=="False") and interseccio==1):
                    #Entrarem el punt4 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                    Crear_Matriu_Boca(matriunova,punt4[0],punt4[1],punt4[2])
                    


            ### CAS [1,0,0,1] ###  ---->>> NO ES POT DONAR AQUEST CAS !!!
            ### CAS [1,1,0,0] ###
            if (area==[1,1,0,0]):
                interseccio=0
                if ((Existeix_Vertex_Boca(matriu_intern,punt1[0],punt1[1],punt1[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt1[0],punt1[1],punt1[2])=="False")):
                    Crear_Matriu_Boca(matriunova,punt1[0],punt1[1],punt1[2])
                                        
                if ((Existeix_Vertex_Boca(matriu_intern,punt2[0],punt2[1],punt2[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt2[0],punt2[1],punt2[2])=="False")):
                    Crear_Matriu_Boca(matriunova,punt2[0],punt2[1],punt2[2])
                                        
                if (HiHa_InterVertical(punt1,punt3,b1,b2)<>"False"):
##                    print "HiHaInterVertical_3"
                    #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                    #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                    #el punt d'intersecci de les dues rectes.
                    t=HiHa_InterVertical(punt1,punt3,b1,b2)
                    a_int_x= punt1[0] - punt1[0]*t + punt3[0]*t
                    a_int_y= punt1[1] - punt1[1]*t + punt3[1]*t
                    punt_inter3=[a_int_x,a_int_y,0]
                    puntvertical1=punt_inter3
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if ((Existeix_Vertex_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])== "False")):
                        Crear_Matriu_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])
                        
                if (HiHa_InterVertical(punt2,punt4,b1,b2)<>"False"):
##                    print "HiHaInterVertical_4"
                    #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                    #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                    #el punt d'intersecci de les dues rectes.
                    t=HiHa_InterVertical(punt2,punt4,b1,b2)
                    a_int_x= punt2[0] - punt2[0]*t + punt4[0]*t
                    a_int_y= punt2[1] - punt2[1]*t + punt4[1]*t
                    punt_inter4=[a_int_x,a_int_y,0]
                    puntvertical2=punt_inter4
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if (Existeix_Vertex_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])== "False"):
                        Crear_Matriu_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])
                        
                                               

            ### CAS [0,1,0,1] ###
            if (area==[0,1,0,1]):
                interseccio=0
                if (HiHa_InterHoritzontal(punt1,punt2,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_1"
                    #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                    #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                    #el punt d'intersecci de les dues rectes.
                    t=HiHa_InterHoritzontal(punt1,punt2,b1,b2)
                    a_int_x= punt1[0] - punt1[0]*t + punt2[0]*t
                    a_int_y= punt1[1] - punt1[1]*t + punt2[1]*t
                    punt_inter1=[a_int_x,a_int_y,0]
                    punthoritzontal1=punt_inter1
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if (Existeix_Vertex_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])== "False"):
                        Crear_Matriu_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])
                        
                if ((Existeix_Vertex_Boca(matriu_intern,punt2[0],punt2[1],punt2[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt2[0],punt2[1],punt2[2])=="False") and interseccio==1):
                    Crear_Matriu_Boca(matriunova,punt2[0],punt2[1],punt2[2])
                    
                    
                if (HiHa_InterHoritzontal(punt3,punt4,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_3"
                    #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                    #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                    #el punt d'intersecci de les dues rectes.
                    t=HiHa_InterHoritzontal(punt3,punt4,b1,b2)
                    a_int_x= punt3[0] - punt3[0]*t + punt4[0]*t
                    a_int_y= punt3[1] - punt3[1]*t + punt4[1]*t
                    punt_inter3=[a_int_x,a_int_y,0]
                    punthoritzontal2=punt_inter3
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if ((Existeix_Vertex_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])== "False")):
                        Crear_Matriu_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])
                        
                if ((Existeix_Vertex_Boca(matriu_intern,punt4[0],punt4[1],punt4[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt4[0],punt4[1],punt4[2])=="False") and interseccio==1):
                    Crear_Matriu_Boca(matriunova,punt4[0],punt4[1],punt4[2])
                                            
                

            ### CAS [0,1,1,0] ### ----->>>> NO ES POT DONAR AQUEST CAS !!!
            ### CAS [1,0,1,0] ###
            if (area==[1,0,1,0]):
                interseccio=0
                if ((Existeix_Vertex_Boca(matriu_intern,punt1[0],punt1[1],punt1[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt1[0],punt1[1],punt1[2])=="False")):
                    Crear_Matriu_Boca(matriunova,punt1[0],punt1[1],punt1[2])
                    
                    
                if (HiHa_InterHoritzontal(punt1,punt2,b1,b2)<>"False"):
##                  print "HiHaInterHoritzontal_2"
                    t = HiHa_InterHoritzontal(punt1,punt2,b1,b2)
                    a_int_x = punt1[0] - punt1[0]*t + punt2[0]*t
                    a_int_y = punt1[1] - punt1[1]*t + punt2[1]*t
                    punt_inter2=[a_int_x,a_int_y,0]
                    punthoritzontal1=punt_inter2
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if (Existeix_Vertex_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])=="False"):
                        Crear_Matriu_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])
                        
                if ((Existeix_Vertex_Boca(matriu_intern,punt3[0],punt3[1],punt3[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt3[0],punt3[1],punt3[2])=="False") and interseccio==1):
                    #Entrarem el punt3 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                    Crear_Matriu_Boca(matriunova,punt3[0],punt3[1],punt3[2])
                    
                if (HiHa_InterHoritzontal(punt3,punt4,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_4"
                    t = HiHa_InterHoritzontal(punt3,punt4,b1,b2)
                    a_int_x = punt3[0] - punt3[0]*t + punt4[0]*t
                    a_int_y = punt3[1] - punt3[1]*t + punt4[1]*t
                    punt_inter4=[a_int_x,a_int_y,0]
                    punthoritzontal2=punt_inter4
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if (Existeix_Vertex_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])=="False" and interseccio==1):
                        Crear_Matriu_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])
                                    
           

        #### - - - - Cas en qu noms tenim un punt dins de la boca - - - - - ####
        if (Hi_Ha_Uns_Vector(area)==1):
            ### Cas [1,0,0,0] ###
            if (area==[1,0,0,0]):
                interseccio=0
                if ((Existeix_Vertex_Boca(matriu_intern,punt1[0],punt1[1],punt1[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt1[0],punt1[1],punt1[2])=="False")):
                    Crear_Matriu_Boca(matriunova,punt1[0],punt1[1],punt1[2])
                    
                        
                if (HiHa_InterHoritzontal(punt1,punt2,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_2"
                    #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                    #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                    #el punt d'intersecci de les dues rectes.
                    t=HiHa_InterHoritzontal(punt1,punt2,b1,b2)
                    a_int_x= punt1[0] - punt1[0]*t + punt2[0]*t
                    a_int_y= punt1[1] - punt1[1]*t + punt2[1]*t
                    punt_inter2=[a_int_x,a_int_y,0]
                    punthoritzontal=punt_inter2
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if (Existeix_Vertex_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])== "False"):
                        Crear_Matriu_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])
                        
                if (HiHa_InterVertical(punt1,punt3,b1,b2)<>"False"):
####                    print "HiHaInterVertical_3"
                    #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                    #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                    #el punt d'intersecci de les dues rectes.
                    t=HiHa_InterVertical(punt1,punt3,b1,b2)
                    a_int_x= punt1[0] - punt1[0]*t + punt3[0]*t
                    a_int_y= punt1[1] - punt1[1]*t + punt3[1]*t
                    punt_inter3=[a_int_x,a_int_y,0]
                    puntvertical=punt_inter3
                    interseccio=1 
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if ((Existeix_Vertex_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])== "False")):
                        Crear_Matriu_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])
                                       
                    

            ### Cas [0,1,0,0] ###
            if (area==[0,1,0,0]):
                interseccio=0
                if (HiHa_InterHoritzontal(punt1,punt2,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_1"
                    #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                    #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                    #el punt d'intersecci de les dues rectes.
                    t=HiHa_InterHoritzontal(punt1,punt2,b1,b2)
                    a_int_x= punt1[0] - punt1[0]*t + punt2[0]*t
                    a_int_y= punt1[1] - punt1[1]*t + punt2[1]*t
                    punt_inter1=[a_int_x,a_int_y,0]
                    punthoritzontal=punt_inter1
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if (Existeix_Vertex_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])== "False"):
                        Crear_Matriu_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])
                        
                if ((Existeix_Vertex_Boca(matriu_intern,punt2[0],punt2[1],punt2[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt2[0],punt2[1],punt2[2])=="False") and interseccio==1):
                    Crear_Matriu_Boca(matriunova,punt2[0],punt2[1],punt2[2])
                    
                    
                if (HiHa_InterVertical(punt2,punt4,b1,b2)<>"False"):
##                    print "HiHaInterVerticlal_4"
                    #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                    #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                    #el punt d'intersecci de les dues rectes.
                    t=HiHa_InterVertical(punt2,punt4,b1,b2)
                    a_int_x= punt2[0] - punt2[0]*t + punt4[0]*t
                    a_int_y= punt2[1] - punt2[1]*t + punt4[1]*t
                    punt_inter4=[a_int_x,a_int_y,0]
                    puntvertical=punt_inter4
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if ((Existeix_Vertex_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])== "False") and (interseccio==1)):
                        Crear_Matriu_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])
                        
                    


            ### Cas [0,0,1,0] ###
            if (area==[0,0,1,0]):
                interseccio=0
                if (HiHa_InterVertical(punt1,punt3,b1,b2)<>"False"):
##                    print "HiHaInterVertical_1"
                    #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                    #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                    #el punt d'intersecci de les dues rectes.
                    t=HiHa_InterVertical(punt1,punt3,b1,b2)
                    a_int_x= punt1[0] - punt1[0]*t + punt3[0]*t
                    a_int_y= punt1[1] - punt1[1]*t + punt3[1]*t
                    punt_inter1=[a_int_x,a_int_y,0]
                    puntvertical=punt_inter1
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if (Existeix_Vertex_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])=="False"):
                        Crear_Matriu_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])
                        
                if ((Existeix_Vertex_Boca(matriu_intern,punt3[0],punt3[1],punt3[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt3[0],punt3[1],punt3[2])=="False") and (interseccio==1)):
                    Crear_Matriu_Boca(matriunova,punt3[0],punt3[1],punt3[2])
                    
                    
                if (HiHa_InterHoritzontal(punt3,punt4,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_4"
                    #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                    #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                    #el punt d'intersecci de les dues rectes.
                    t=HiHa_InterHoritzontal(punt3,punt4,b1,b2)
                    a_int_x= punt3[0] - punt3[0]*t + punt4[0]*t
                    a_int_y= punt3[1] - punt3[1]*t + punt4[1]*t
                    punt_inter4=[a_int_x,a_int_y,0]
                    punthoritzontal=punt_inter4
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if ((Existeix_Vertex_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])== "False") and (interseccio==1)):
                        Crear_Matriu_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])
                        

            ### Cas [0,0,0,1] ###
            if (area==[0,0,0,1]):
                interseccio=0
                if (HiHa_InterVertical(punt2,punt4,b1,b2)<>"False"):
##                    print "HiHaInterVertical_2"
                    #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                    #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                    #el punt d'intersecci de les dues rectes.
                    t=HiHa_InterVertical(punt2,punt4,b1,b2)
                    a_int_x= punt2[0] - punt2[0]*t + punt4[0]*t
                    a_int_y= punt2[1] - punt2[1]*t + punt4[1]*t
                    punt_inter2=[a_int_x,a_int_y,0]
                    puntvertical=punt_inter2
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if (Existeix_Vertex_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])== "False"):
                        Crear_Matriu_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])
                        
                if (HiHa_InterHoritzontal(punt3,punt4,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_3"
                    #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                    #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                    #el punt d'intersecci de les dues rectes.
                    t=HiHa_InterHoritzontal(punt3,punt4,b1,b2)
                    a_int_x= punt3[0] - punt3[0]*t + punt4[0]*t
                    a_int_y= punt3[1] - punt3[1]*t + punt4[1]*t
                    punt_inter3=[a_int_x,a_int_y,0]
                    punthoritzontal=punt_inter3
                    interseccio=1
                    #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                    if ((Existeix_Vertex_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])== "False") ):
                        Crear_Matriu_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])
                        
                if ((Existeix_Vertex_Boca(matriu_intern,punt4[0],punt4[1],punt4[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt4[0],punt4[1],punt4[2])=="False") and (interseccio==1)):
                    Crear_Matriu_Boca(matriunova,punt4[0],punt4[1],punt4[2])
                    
       
                
                                        
                

    
    #Faig tot el qu he fet abans per a la ltima posici que enganxa amb el zero
    b1=matriu_contorn.Matriu_Vertex_Boca[matriu_contorn.fila-1]
    b2=matriu_contorn.Matriu_Vertex_Boca[0]
##    print "b1: ",b1,"b2: ",b2
    #### - - - -Cas en qu tots els punts es troben a l'interior de la boca- - - - ####
    if (Hi_Ha_Uns_Vector(area)==4):
        if ((Existeix_Vertex_Boca(matriu_intern,punt1[0],punt1[1],punt1[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt1[0],punt1[1],punt1[2])=="False")):
            Crear_Matriu_Boca(matriunova,punt1[0],punt1[1],punt1[2])
            
        if ((Existeix_Vertex_Boca(matriu_intern,punt2[0],punt2[1],punt2[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt2[0],punt2[1],punt2[2])=="False")):
            Crear_Matriu_Boca(matriunova,punt2[0],punt2[1],punt2[2])
            
            
        if ((Existeix_Vertex_Boca(matriu_intern,punt3[0],punt3[1],punt3[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt3[0],punt3[1],punt3[2])=="False")):
            #Entrarem el punt3 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
            Crear_Matriu_Boca(matriunova,punt3[0],punt3[1],punt3[2])
            
        if ((Existeix_Vertex_Boca(matriu_intern,punt4[0],punt4[1],punt4[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt4[0],punt4[1],punt4[2])=="False")):
            #Entrarem el punt4 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
            Crear_Matriu_Boca(matriunova,punt4[0],punt4[1],punt4[2])
            
            
    #### - - - -Cas en qu 3 vectors es troben a l'interior de la boca- - - - - - ####
    if (Hi_Ha_Uns_Vector(area)==3):
        ### Cas [0,1,1,1] ###
        if (area==[0,1,1,1]):
            interseccio=0
            
            if (HiHa_InterVertical(punt1,punt3,b1,b2)<>"False"):
##                    print "HiHaInterVertical_1"
                #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                #el punt d'intersecci de les dues rectes.
                t=HiHa_InterVertical(punt1,punt3,b1,b2)
                a_int_x= punt1[0] - punt1[0]*t + punt3[0]*t
                a_int_y= punt1[1] - punt1[1]*t + punt3[1]*t
                punt_inter1=[a_int_x,a_int_y,0]
                puntvertical=punt_inter1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if (Existeix_Vertex_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])== "False"):
                    Crear_Matriu_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])
                interseccio=1
                    
            if (HiHa_InterHoritzontal(punt1,punt2,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_1"
                t = HiHa_InterHoritzontal(punt1,punt2,b1,b2)
                a_int_x = punt1[0] - punt1[0]*t + punt2[0]*t
                a_int_y = punt1[1] - punt1[1]*t + punt2[1]*t
                punt_inter1=[a_int_x,a_int_y,0]
                punthoritzontal=punt_inter1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if (Existeix_Vertex_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])=="False"):
                    Crear_Matriu_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])
                interseccio=1
                                                
            #En aquest punt ja haurem insertat les dues interseccions
            #Ara hem d'insertar el punt 2
            if ((Existeix_Vertex_Boca(matriu_intern,punt2[0],punt2[1],punt2[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt2[0],punt2[1],punt2[2])=="False") and (interseccio==1)):
                Crear_Matriu_Boca(matriunova,punt2[0],punt2[1],punt2[2])
                                             
                
            if ((Existeix_Vertex_Boca(matriu_intern,punt3[0],punt3[1],punt3[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt3[0],punt3[1],punt3[2])=="False") and (interseccio==1)):
                #Entrarem el punt3 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                Crear_Matriu_Boca(matriunova,punt3[0],punt3[1],punt3[2])
                                                                        
            if ((Existeix_Vertex_Boca(matriu_intern,punt4[0],punt4[1],punt4[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt4[0],punt4[1],punt4[2])=="False") and (interseccio==1)):
                #Entrarem el punt4 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                Crear_Matriu_Boca(matriunova,punt4[0],punt4[1],punt4[2])
                                    
                                   
        ### CAS [1,0,1,1] ###
        if (area==[1,0,1,1]):
            interseccio=0
            if ((Existeix_Vertex_Boca(matriu_intern,punt1[0],punt1[1],punt1[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt1[0],punt1[1],punt1[2])=="False")):
                Crear_Matriu_Boca(matriunova,punt1[0],punt1[1],punt1[2])
                                                           
                
            if (HiHa_InterHoritzontal(punt1,punt2,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_2"
                t = HiHa_InterHoritzontal(punt1,punt2,b1,b2)
                a_int_x = punt1[0] - punt1[0]*t + punt2[0]*t
                a_int_y = punt1[1] - punt1[1]*t + punt2[1]*t
                punt_inter2=[a_int_x,a_int_y,0]
                punthoritzontal=punt_inter2
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if (Existeix_Vertex_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])=="False"):
                    Crear_Matriu_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])
            if (HiHa_InterVertical(punt2,punt4,b1,b2)<>"False"):
##                    print "HiHaInterVertical_2"
                t = HiHa_InterVertical(punt2,punt4,b1,b2)
                a_int_x = punt2[0] - punt2[0]*t + punt4[0]*t
                a_int_y = punt2[1] - punt2[1]*t + punt4[1]*t
                punt_inter2=[a_int_x,a_int_y,0]
                puntvertical=punt_inter2
                interseccio=1
                #ja podem insertar aquest "punt_inter2" a la "matriunova"
                if (Existeix_Vertex_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])=="False"):
                    Crear_Matriu_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])
                    
            if ((Existeix_Vertex_Boca(matriu_intern,punt3[0],punt3[1],punt3[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt3[0],punt3[1],punt3[2])=="False") and interseccio==1):
                #Entrarem el punt3 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                Crear_Matriu_Boca(matriunova,punt3[0],punt3[1],punt3[2])
               
            if ((Existeix_Vertex_Boca(matriu_intern,punt4[0],punt4[1],punt4[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt4[0],punt4[1],punt4[2])=="False") and interseccio==1):
                #Entrarem el punt4 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                Crear_Matriu_Boca(matriunova,punt4[0],punt4[1],punt4[2])
                
        ### CAS [1,1,0,1] ###
        if (area==[1,1,0,1]):
            interseccio=0
            if ((Existeix_Vertex_Boca(matriu_intern,punt1[0],punt1[1],punt1[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt1[0],punt1[1],punt1[2])=="False")):
                Crear_Matriu_Boca(matriunova,punt1[0],punt1[1],punt1[2])
                                    
            if ((Existeix_Vertex_Boca(matriu_intern,punt2[0],punt2[1],punt2[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt2[0],punt2[1],punt2[2])=="False")):
                Crear_Matriu_Boca(matriunova,punt2[0],punt2[1],punt2[2])
                                   
            if (HiHa_InterVertical(punt1,punt3,b1,b2)<>"False"):
##                    print "HiHaInterVertical_3"
                #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                #el punt d'intersecci de les dues rectes.
                t=HiHa_InterVertical(punt1,punt3,b1,b2)
                a_int_x= punt1[0] - punt1[0]*t + punt3[0]*t
                a_int_y= punt1[1] - punt1[1]*t + punt3[1]*t
                punt_inter3=[a_int_x,a_int_y,0]
                puntvertical=punt_inter3
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if ((Existeix_Vertex_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])== "False")):
                    Crear_Matriu_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])
                    
            if (HiHa_InterHoritzontal(punt3,punt4,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_3"
                t = HiHa_InterHoritzontal(punt3,punt4,b1,b2)
                a_int_x = punt3[0] - punt3[0]*t + punt4[0]*t
                a_int_y = punt3[1] - punt3[1]*t + punt4[1]*t
                punt_inter3=[a_int_x,a_int_y,0]
                punthoritzontal=punt_inter3
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if (Existeix_Vertex_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])=="False"):
                    Crear_Matriu_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])
                    
            if ((Existeix_Vertex_Boca(matriu_intern,punt4[0],punt4[1],punt4[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt4[0],punt4[1],punt4[2])=="False") and interseccio==1):
                #Entrarem el punt4 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                Crear_Matriu_Boca(matriunova,punt4[0],punt4[1],punt4[2])
                
                
        ### CAS [1,1,1,0] ###
        if (area==[1,1,1,0]):
            interseccio=0
            if ((Existeix_Vertex_Boca(matriu_intern,punt1[0],punt1[1],punt1[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt1[0],punt1[1],punt1[2])=="False")):
                Crear_Matriu_Boca(matriunova,punt1[0],punt1[1],punt1[2])
                                    
            if ((Existeix_Vertex_Boca(matriu_intern,punt2[0],punt2[1],punt2[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt2[0],punt2[1],punt2[2])=="False")):
                Crear_Matriu_Boca(matriunova,punt2[0],punt2[1],punt2[2])
                                    
            if ((Existeix_Vertex_Boca(matriu_intern,punt3[0],punt3[1],punt3[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt3[0],punt3[1],punt3[2])=="False")):
                #Entrarem el punt3 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                Crear_Matriu_Boca(matriunova,punt3[0],punt3[1],punt3[2])
                
            if (HiHa_InterHoritzontal(punt3,punt4,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_4"
                t = HiHa_InterHoritzontal(punt3,punt4,b1,b2)
                a_int_x = punt3[0] - punt3[0]*t + punt4[0]*t
                a_int_y = punt3[1] - punt3[1]*t + punt4[1]*t
                punt_inter4=[a_int_x,a_int_y,0]
                punthoritzontal=punt_inter4
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if ((Existeix_Vertex_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])=="False")):
                    Crear_Matriu_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])
                    
            if (HiHa_InterVertical(punt2,punt4,b1,b2)<>"False"):
##                    print "HiHaInterVertical_4"
                #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                #el punt d'intersecci de les dues rectes.
                t=HiHa_InterVertical(punt2,punt4,b1,b2)
                a_int_x= punt2[0] - punt2[0]*t + punt4[0]*t
                a_int_y= punt2[1] - punt2[1]*t + punt4[1]*t
                punt_inter4=[a_int_x,a_int_y,0]
                puntvertical=punt_inter4
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if ((Existeix_Vertex_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])== "False")):
                    Crear_Matriu_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])
                    
                           
    #### - - - -Cas en qu 2 vectors es troben a l'interior de la boca - - - - - - ####
    if (Hi_Ha_Uns_Vector(area)==2):
        ### Cas [0,0,1,1] ###
        if (area==[0,0,1,1]):
            interseccio=0
            if (HiHa_InterVertical(punt1,punt3,b1,b2)<>"False"):
##                    print "HiHaInterVertical_1"
                #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                #el punt d'intersecci de les dues rectes.
                t=HiHa_InterVertical(punt1,punt3,b1,b2)
                a_int_x= punt1[0] - punt1[0]*t + punt3[0]*t
                a_int_y= punt1[1] - punt1[1]*t + punt3[1]*t
                punt_inter1=[a_int_x,a_int_y,0]
                puntvertical1=punt_inter1
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if (Existeix_Vertex_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])== "False"):
                    Crear_Matriu_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])
                    
            if (HiHa_InterVertical(punt2,punt4,b1,b2)<>"False"):
##              print "HiHaInterVertical_2"
                #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                #el punt d'intersecci de les dues rectes.
                t=HiHa_InterVertical(punt2,punt4,b1,b2)
                a_int_x= punt2[0] - punt2[0]*t + punt4[0]*t
                a_int_y= punt2[1] - punt2[1]*t + punt4[1]*t
                punt_inter2=[a_int_x,a_int_y,0]
                puntvertical2=punt_inter2
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if (Existeix_Vertex_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])== "False"):
                    Crear_Matriu_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])
                    
            if ((Existeix_Vertex_Boca(matriu_intern,punt3[0],punt3[1],punt3[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt3[0],punt3[1],punt3[2])=="False") and interseccio==1):
                #Entrarem el punt3 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                Crear_Matriu_Boca(matriunova,punt3[0],punt3[1],punt3[2])
                
            if ((Existeix_Vertex_Boca(matriu_intern,punt4[0],punt4[1],punt4[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt4[0],punt4[1],punt4[2])=="False") and interseccio==1):
                #Entrarem el punt4 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                Crear_Matriu_Boca(matriunova,punt4[0],punt4[1],punt4[2])
                


        ### CAS [1,0,0,1] ###  ---->>> NO ES POT DONAR AQUEST CAS !!!
        ### CAS [1,1,0,0] ###
        if (area==[1,1,0,0]):
            interseccio=0
            if ((Existeix_Vertex_Boca(matriu_intern,punt1[0],punt1[1],punt1[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt1[0],punt1[1],punt1[2])=="False")):
                Crear_Matriu_Boca(matriunova,punt1[0],punt1[1],punt1[2])
                                    
            if ((Existeix_Vertex_Boca(matriu_intern,punt2[0],punt2[1],punt2[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt2[0],punt2[1],punt2[2])=="False")):
                Crear_Matriu_Boca(matriunova,punt2[0],punt2[1],punt2[2])
                                    
            if (HiHa_InterVertical(punt1,punt3,b1,b2)<>"False"):
##                    print "HiHaInterVertical_3"
                #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                #el punt d'intersecci de les dues rectes.
                t=HiHa_InterVertical(punt1,punt3,b1,b2)
                a_int_x= punt1[0] - punt1[0]*t + punt3[0]*t
                a_int_y= punt1[1] - punt1[1]*t + punt3[1]*t
                punt_inter3=[a_int_x,a_int_y,0]
                puntvertical1=punt_inter3
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if ((Existeix_Vertex_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])== "False")):
                    Crear_Matriu_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])
                    
            if (HiHa_InterVertical(punt2,punt4,b1,b2)<>"False"):
##                    print "HiHaInterVertical_4"
                #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                #el punt d'intersecci de les dues rectes.
                t=HiHa_InterVertical(punt2,punt4,b1,b2)
                a_int_x= punt2[0] - punt2[0]*t + punt4[0]*t
                a_int_y= punt2[1] - punt2[1]*t + punt4[1]*t
                punt_inter4=[a_int_x,a_int_y,0]
                puntvertical2=punt_inter4
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if (Existeix_Vertex_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])== "False"):
                    Crear_Matriu_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])
                    
                                           

        ### CAS [0,1,0,1] ###
        if (area==[0,1,0,1]):
            interseccio=0
            if (HiHa_InterHoritzontal(punt1,punt2,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_1"
                #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                #el punt d'intersecci de les dues rectes.
                t=HiHa_InterHoritzontal(punt1,punt2,b1,b2)
                a_int_x= punt1[0] - punt1[0]*t + punt2[0]*t
                a_int_y= punt1[1] - punt1[1]*t + punt2[1]*t
                punt_inter1=[a_int_x,a_int_y,0]
                punthoritzontal1=punt_inter1
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if (Existeix_Vertex_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])== "False"):
                    Crear_Matriu_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])
                    
            if ((Existeix_Vertex_Boca(matriu_intern,punt2[0],punt2[1],punt2[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt2[0],punt2[1],punt2[2])=="False") and interseccio==1):
                Crear_Matriu_Boca(matriunova,punt2[0],punt2[1],punt2[2])
                
                
            if (HiHa_InterHoritzontal(punt3,punt4,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_3"
                #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                #el punt d'intersecci de les dues rectes.
                t=HiHa_InterHoritzontal(punt3,punt4,b1,b2)
                a_int_x= punt3[0] - punt3[0]*t + punt4[0]*t
                a_int_y= punt3[1] - punt3[1]*t + punt4[1]*t
                punt_inter3=[a_int_x,a_int_y,0]
                punthoritzontal2=punt_inter3
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if ((Existeix_Vertex_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])== "False")):
                    Crear_Matriu_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])
                    
            if ((Existeix_Vertex_Boca(matriu_intern,punt4[0],punt4[1],punt4[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt4[0],punt4[1],punt4[2])=="False") and interseccio==1):
                Crear_Matriu_Boca(matriunova,punt4[0],punt4[1],punt4[2])
                                        
            

        ### CAS [0,1,1,0] ### ----->>>> NO ES POT DONAR AQUEST CAS !!!
        ### CAS [1,0,1,0] ###
        if (area==[1,0,1,0]):
            interseccio=0
            if ((Existeix_Vertex_Boca(matriu_intern,punt1[0],punt1[1],punt1[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt1[0],punt1[1],punt1[2])=="False")):
                Crear_Matriu_Boca(matriunova,punt1[0],punt1[1],punt1[2])
                
                
            if (HiHa_InterHoritzontal(punt1,punt2,b1,b2)<>"False"):
##                  print "HiHaInterHoritzontal_2"
                t = HiHa_InterHoritzontal(punt1,punt2,b1,b2)
                a_int_x = punt1[0] - punt1[0]*t + punt2[0]*t
                a_int_y = punt1[1] - punt1[1]*t + punt2[1]*t
                punt_inter2=[a_int_x,a_int_y,0]
                punthoritzontal1=punt_inter2
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if (Existeix_Vertex_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])=="False"):
                    Crear_Matriu_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])
                    
            if ((Existeix_Vertex_Boca(matriu_intern,punt3[0],punt3[1],punt3[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt3[0],punt3[1],punt3[2])=="False") and interseccio==1):
                #Entrarem el punt3 a la matriu matriufilaultima i el final haurem d'entrar aquesta matriu a la matriunova
                Crear_Matriu_Boca(matriunova,punt3[0],punt3[1],punt3[2])
                
            if (HiHa_InterHoritzontal(punt3,punt4,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_4"
                t = HiHa_InterHoritzontal(punt3,punt4,b1,b2)
                a_int_x = punt3[0] - punt3[0]*t + punt4[0]*t
                a_int_y = punt3[1] - punt3[1]*t + punt4[1]*t
                punt_inter4=[a_int_x,a_int_y,0]
                punthoritzontal2=punt_inter4
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if (Existeix_Vertex_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])=="False" and interseccio==1):
                    Crear_Matriu_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])
                                
       

    #### - - - - Cas en qu noms tenim un punt dins de la boca - - - - - ####
    if (Hi_Ha_Uns_Vector(area)==1):
        ### Cas [1,0,0,0] ###
        if (area==[1,0,0,0]):
            interseccio=0
            if ((Existeix_Vertex_Boca(matriu_intern,punt1[0],punt1[1],punt1[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt1[0],punt1[1],punt1[2])=="False")):
                Crear_Matriu_Boca(matriunova,punt1[0],punt1[1],punt1[2])
                
                    
            if (HiHa_InterHoritzontal(punt1,punt2,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_2"
                #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                #el punt d'intersecci de les dues rectes.
                t=HiHa_InterHoritzontal(punt1,punt2,b1,b2)
                a_int_x= punt1[0] - punt1[0]*t + punt2[0]*t
                a_int_y= punt1[1] - punt1[1]*t + punt2[1]*t
                punt_inter2=[a_int_x,a_int_y,0]
                punthoritzontal=punt_inter2
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if (Existeix_Vertex_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])== "False"):
                    Crear_Matriu_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])
                    
            if (HiHa_InterVertical(punt1,punt3,b1,b2)<>"False"):
####                    print "HiHaInterVertical_3"
                #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                #el punt d'intersecci de les dues rectes.
                t=HiHa_InterVertical(punt1,punt3,b1,b2)
                a_int_x= punt1[0] - punt1[0]*t + punt3[0]*t
                a_int_y= punt1[1] - punt1[1]*t + punt3[1]*t
                punt_inter3=[a_int_x,a_int_y,0]
                puntvertical=punt_inter3
                interseccio=1 
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if ((Existeix_Vertex_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])== "False")):
                    Crear_Matriu_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])
                                   
                

        ### Cas [0,1,0,0] ###
        if (area==[0,1,0,0]):
            interseccio=0
            if (HiHa_InterHoritzontal(punt1,punt2,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_1"
                #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                #el punt d'intersecci de les dues rectes.
                t=HiHa_InterHoritzontal(punt1,punt2,b1,b2)
                a_int_x= punt1[0] - punt1[0]*t + punt2[0]*t
                a_int_y= punt1[1] - punt1[1]*t + punt2[1]*t
                punt_inter1=[a_int_x,a_int_y,0]
                punthoritzontal=punt_inter1
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if (Existeix_Vertex_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])== "False"):
                    Crear_Matriu_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])
                    
            if ((Existeix_Vertex_Boca(matriu_intern,punt2[0],punt2[1],punt2[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt2[0],punt2[1],punt2[2])=="False") and interseccio==1):
                Crear_Matriu_Boca(matriunova,punt2[0],punt2[1],punt2[2])
                
                
            if (HiHa_InterVertical(punt2,punt4,b1,b2)<>"False"):
##                    print "HiHaInterVerticlal_4"
                #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                #el punt d'intersecci de les dues rectes.
                t=HiHa_InterVertical(punt2,punt4,b1,b2)
                a_int_x= punt2[0] - punt2[0]*t + punt4[0]*t
                a_int_y= punt2[1] - punt2[1]*t + punt4[1]*t
                punt_inter4=[a_int_x,a_int_y,0]
                puntvertical=punt_inter4
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if ((Existeix_Vertex_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])== "False") and (interseccio==1)):
                    Crear_Matriu_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])
                    
                


        ### Cas [0,0,1,0] ###
        if (area==[0,0,1,0]):
            interseccio=0
            if (HiHa_InterVertical(punt1,punt3,b1,b2)<>"False"):
##                    print "HiHaInterVertical_1"
                #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                #el punt d'intersecci de les dues rectes.
                t=HiHa_InterVertical(punt1,punt3,b1,b2)
                a_int_x= punt1[0] - punt1[0]*t + punt3[0]*t
                a_int_y= punt1[1] - punt1[1]*t + punt3[1]*t
                punt_inter1=[a_int_x,a_int_y,0]
                puntvertical=punt_inter1
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if (Existeix_Vertex_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])=="False"):
                    Crear_Matriu_Boca(matriunova,punt_inter1[0],punt_inter1[1],punt_inter1[2])
                    
            if ((Existeix_Vertex_Boca(matriu_intern,punt3[0],punt3[1],punt3[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt3[0],punt3[1],punt3[2])=="False") and (interseccio==1)):
                Crear_Matriu_Boca(matriunova,punt3[0],punt3[1],punt3[2])
                
                
            if (HiHa_InterHoritzontal(punt3,punt4,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_4"
                #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                #el punt d'intersecci de les dues rectes.
                t=HiHa_InterHoritzontal(punt3,punt4,b1,b2)
                a_int_x= punt3[0] - punt3[0]*t + punt4[0]*t
                a_int_y= punt3[1] - punt3[1]*t + punt4[1]*t
                punt_inter4=[a_int_x,a_int_y,0]
                punthoritzontal=punt_inter4
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if ((Existeix_Vertex_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])== "False") and (interseccio==1)):
                    Crear_Matriu_Boca(matriunova,punt_inter4[0],punt_inter4[1],punt_inter4[2])
                    

        ### Cas [0,0,0,1] ###
        if (area==[0,0,0,1]):
            interseccio=0
            if (HiHa_InterVertical(punt2,punt4,b1,b2)<>"False"):
##                    print "HiHaInterVertical_2"
                #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                #el punt d'intersecci de les dues rectes.
                t=HiHa_InterVertical(punt2,punt4,b1,b2)
                a_int_x= punt2[0] - punt2[0]*t + punt4[0]*t
                a_int_y= punt2[1] - punt2[1]*t + punt4[1]*t
                punt_inter2=[a_int_x,a_int_y,0]
                puntvertical=punt_inter2
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if (Existeix_Vertex_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])== "False"):
                    Crear_Matriu_Boca(matriunova,punt_inter2[0],punt_inter2[1],punt_inter2[2])
                    
            if (HiHa_InterHoritzontal(punt3,punt4,b1,b2)<>"False"):
##                    print "HiHaInterHoritzontal_3"
                #Haurem de comprovar quin s el punt que haurem de descartar i afegir-hi el nou punt d'intersecci
                #La funci HiHa_InterVertical() si no retorna "False" retorna el valor de t que ens serveix per calcular
                #el punt d'intersecci de les dues rectes.
                t=HiHa_InterHoritzontal(punt3,punt4,b1,b2)
                a_int_x= punt3[0] - punt3[0]*t + punt4[0]*t
                a_int_y= punt3[1] - punt3[1]*t + punt4[1]*t
                punt_inter3=[a_int_x,a_int_y,0]
                punthoritzontal=punt_inter3
                interseccio=1
                #Ja podem insertar aquest "punt_inter1" a la "matriunova"
                if ((Existeix_Vertex_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])== "False") ):
                    Crear_Matriu_Boca(matriunova,punt_inter3[0],punt_inter3[1],punt_inter3[2])
                    
            if ((Existeix_Vertex_Boca(matriu_intern,punt4[0],punt4[1],punt4[2])=="True") and (Existeix_Vertex_Boca(matriunova,punt4[0],punt4[1],punt4[2])=="False") and (interseccio==1)):
                Crear_Matriu_Boca(matriunova,punt4[0],punt4[1],punt4[2])
                    
                

   

    #Quan arribem a aquest punt ja tindrem els punts que necessitem per fer la triangulaci
    #------------------ Fem la triangulaci -----------------------
    if (Hi_Ha_Uns_Vector(area)==4):
        Realitzar_Triangulacio4(punt1,punt2,punt3,punt4,matriunova,Trident,Llista_Triangles)
    if (Hi_Ha_Uns_Vector(area)==3):
        if (area==[0,1,1,1]):
            Realitzar_Triangulacio5a(puntvertical,punthoritzontal,punt2,punt3,punt4,matriunova,Trident,Llista_Triangles)
        if (area==[1,0,1,1]):
            Realitzar_Triangulacio5a(punt1,punthoritzontal,puntvertical,punt3,punt4,matriunova,Trident,Llista_Triangles)
        if (area==[1,1,0,1]):
            Realitzar_Triangulacio5b(punt1,punt2,puntvertical,punthoritzontal,punt4,matriunova,Trident,Llista_Triangles)
        if (area==[1,1,1,0]):
            Realitzar_Triangulacio5b(punt1,punt2,punt3,punthoritzontal,puntvertical,matriunova,Trident,Llista_Triangles)
    if (Hi_Ha_Uns_Vector(area)==2):
        if (area==[0,0,1,1]):
            Realitzar_Triangulacio4(puntvertical1,puntvertical2,punt3,punt4,matriunova,Trident,Llista_Triangles)
        if (area==[1,1,0,0]):
            Realitzar_Triangulacio4(punt1,punt2,puntvertical1,puntvertical2,matriunova,Trident,Llista_Triangles)
        if (area==[0,1,0,1]):
            Realitzar_Triangulacio4(punthoritzontal1,punt2,punthoritzontal2,punt4,matriunova,Trident,Llista_Triangles)
        if (area==[1,0,1,0]):
            Realitzar_Triangulacio4(punt1,punthoritzontal1,punt3,punthoritzontal2,matriunova,Trident,Llista_Triangles)
    if (Hi_Ha_Uns_Vector(area)==1):
        if (area==[1,0,0,0]):
            Realitzar_Triangulacio3(punt1,punthoritzontal,puntvertical,matriunova,Trident,Llista_Triangles)
        if (area==[0,1,0,0]):
            Realitzar_Triangulacio3(punthoritzontal,punt2,puntvertical,matriunova,Trident,Llista_Triangles)
        if (area==[0,0,1,0]):
            Realitzar_Triangulacio3(puntvertical,punt3,punthoritzontal,matriunova,Trident,Llista_Triangles)
        if (area==[0,0,0,1]):
            Realitzar_Triangulacio3(puntvertical,punthoritzontal,punt4,matriunova,Trident,Llista_Triangles)
       
def ExisteixPosicio(matriu,posicio):

    resultat="False"
    for i in range(0,matriu.fila):
        if (posicio==matriu.Matriu_Vertex_Boca[i][3]):
            resultat="True"
            break
    return(resultat)

                    
def UnioTriangulacio(Llista_Triangles):

    #l'rea de la triangulaci t 4 elements que determinen els 4 vrtexs per a fer-ne la uni
    #for i in range (0, matriu.fila):
    
    
    #Primerament tinc que saber quina s la posicio ms gran que hem insertat:
    #Aquesta posicio es trobar a l'ltim vrtexs insertat a la nostra matriu.

    for i in range (0,Llista_Triangles.fila):
        cara=NMesh.Face()
        cara.append(poligon2.verts[Llista_Triangles.Matriu_Vertex_Boca[i][0]])
        cara.append(poligon2.verts[Llista_Triangles.Matriu_Vertex_Boca[i][1]])
        cara.append(poligon2.verts[Llista_Triangles.Matriu_Vertex_Boca[i][2]])
        poligon2.faces.append(cara)
        
   

def Realitzar_Triangulacio4(punt1,punt2,punt3,punt4,matriunova,Trident,Llista_Triangles):

    #d'aqu en sortiran 2 triangles
    #--------- TRIANGLE 1 ------
    #Afegim el Punt1
    posicio=Buscar_Posicio(matriunova,punt1)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt2
    posicio=Buscar_Posicio(matriunova,punt2)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt3
    posicio=Buscar_Posicio(matriunova,punt3)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #-------- TRIANGLE 2 ---------
    #Afegim el Punt2
    posicio=Buscar_Posicio(matriunova,punt2)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt3
    posicio=Buscar_Posicio(matriunova,punt3)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt4
    posicio=Buscar_Posicio(matriunova,punt4)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)     

    ##---- ARA TORNEM A CREAR ELS TRIANGLES PER AL REVS PERQU ES VEIGUIN LES ALTRES CARES

    ##......... TRIANGLE 1 .............
    #Afegim el Punt1
    posicio=Buscar_Posicio(matriunova,punt1)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt3
    posicio=Buscar_Posicio(matriunova,punt3)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt2
    posicio=Buscar_Posicio(matriunova,punt2)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    ##.......... TRIANGLE 2 ...........
    #Afegim el Punt2
    posicio=Buscar_Posicio(matriunova,punt2)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt4
    posicio=Buscar_Posicio(matriunova,punt4)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident) 

    #Afegim el Punt3
    posicio=Buscar_Posicio(matriunova,punt3)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

     
    

def Realitzar_Triangulacio5a(punt1,punt2,punt3,punt4,punt5,matriunova,Trident,Llista_Triangles):
    
    #d'aqu en sortiran 3 triangles
    #--------- TRIANGLE 1 ------
    #Afegim el Punt1
    posicio=Buscar_Posicio(matriunova,punt1)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt2
    posicio=Buscar_Posicio(matriunova,punt2)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt4
    posicio=Buscar_Posicio(matriunova,punt4)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #--------- TRIANGLE 2 ------
    #Afegim el Punt2
    posicio=Buscar_Posicio(matriunova,punt2)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt3
    posicio=Buscar_Posicio(matriunova,punt3)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt4
    posicio=Buscar_Posicio(matriunova,punt4)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)        

    #--------- TRIANGLE 3 ------
    #Afegim el Punt3
    posicio=Buscar_Posicio(matriunova,punt3)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt4
    posicio=Buscar_Posicio(matriunova,punt4)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt5
    posicio=Buscar_Posicio(matriunova,punt5)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)



def Realitzar_Triangulacio5b(punt1,punt2,punt3,punt4,punt5,matriunova,Trident,Llista_Triangles):
     #d'aqu en sortiran 3 triangles
    #--------- TRIANGLE 1 ------
    #Afegim el Punt1
    posicio=Buscar_Posicio(matriunova,punt1)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt2
    posicio=Buscar_Posicio(matriunova,punt2)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt3
    posicio=Buscar_Posicio(matriunova,punt3)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #--------- TRIANGLE 2 --------
    #Afegim el Punt2
    posicio=Buscar_Posicio(matriunova,punt2)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt3
    posicio=Buscar_Posicio(matriunova,punt3)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt4
    posicio=Buscar_Posicio(matriunova,punt4)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #--------- TRIANGLE 3 ---------
    #Afegim el Punt2
    posicio=Buscar_Posicio(matriunova,punt2)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt4
    posicio=Buscar_Posicio(matriunova,punt4)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt5
    posicio=Buscar_Posicio(matriunova,punt5)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)    

def Realitzar_Triangulacio3(punt1,punt2,punt3,matriunova,Trident,Llista_Triangles):
     #d'aqu en sortira 1 triangle
    #--------- TRIANGLE 1 ------
    #Afegim el Punt1
    posicio=Buscar_Posicio(matriunova,punt1)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt2
    posicio=Buscar_Posicio(matriunova,punt2)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)

    #Afegim el Punt3
    posicio=Buscar_Posicio(matriunova,punt3)
    Crear_Triangle(Trident,posicio)
    Afegir_Triangle_Llista(Llista_Triangles,Trident)    

    

#Tant el pas de la triangulaci com el de CrearPuntsInteriors2 han de tenir el mateix valor
#La matriu_contorn ens serveix per delimitar els nostres lmits.
#La matriu_interior ens serveix per saber els punts que tenim dins la nostra boca
def Triangulacio (matriu_contorn, matriu_interior):
    #La variable comptador ens indicar quantes vegades intersecta el vertex candidat quan llencem una recta vertical.
    comptador=0
    llargadaN=0 #Aquesta variable ens dir quina amplada (de X)t la nostra matriu, s a dir, quants N tenim.
      
    #La variable pas s l'increment que fa el bucle del for
    # per defecte anir a pas 1.
    #necessitem una matriu nova per passar-hi els punts que no formen part de la matriu
    matriu_nova = Matriu_Nova()
    pas= 20
    maximaY = int(Ymax(matriu_contorn))
    maximaX = int(Xmax(matriu_contorn))
    minimaY = int(Ymin(matriu_contorn))
    minimaX = int(Xmin(matriu_contorn))
   
    #limitem la nostra rea segons un quadrat (els punts sern vectors)

    #Limit_Esq_Sota         part esquerra inferior
    #Limit_Esq_Sobre        part esquerra superior
    #Limit_Dreta_Sota       part dreta inferior
    #Limit_Dreta_Sobre      part dreta superior

    Limit_Esq_Sota= [minimaX, minimaY, 0]
    Limit_Esq_Sobre = [minimaX, maximaY, 0]
    Limit_Dreta_Sota = [maximaX, minimaY, 0]
    Limit_Dreta_Sobre = [maximaX, maximaY, 0]

####    print "Limit Dreta Sota: ", Limit_Dreta_Sota
##    print "Limit Dreta Sobre: ",Limit_Dreta_Sobre
##    print "Limit Esquerra Sota: ",Limit_Esq_Sota
##    print "Limit Esquerra Sobre: ",Limit_Esq_Sobre

    #segons la meva idea haur de fer una comparaci amb els punts de la matriu que formen
    #part de la meva boca i els punts que no. Els punts que coincideixin amb la matriu
    #de dins la boca tindran un valor de 1 i els que no pertanyen tindran valor de 0

    Area_Triangulacio=Vector_Triangulacio() #s l'rea que contindr els vrtexs de triangulaci (bons i no tant bons)
    Punts_Triangulacio=Matriu_Triangulacio() #Aqu hi guardarem tots els punts que haguem de triangular;
    #es trobin, o no, a dins de la nostra boca.
    Llista_Triangles=Matriu_Nova() #Aquesta llista cont els triangles que haurem d'afegir el final
    #La llista_Triangles t la quantitat de triangles que haurem de construir i a ms la posici
    #de on es troben en la llista del polgon de blender
    Trident=Triangle() #Aquesta variable "Trident" contindr un triangle amb 3 vrtexs
    #(3posicions de vrtexs en la llista del blender)
    posi=0 #Aquesta variable ens compta els elements que tenim en una matriu quadrada m x m que s
    #el patr de la nostra matriu a triangular.

    #Els lmits em serviaran per saber si els punts es troben a dins o
    # a fora de la nostra boca, juntament amb la funci Cross_Product.
    for y in range(minimaY, maximaY, pas):#podrem ajustar ms i fer maximaY+pas a dins del for
        llargadaN=0
        for x in range(minimaX, maximaX, pas):#podrem ajustar ms i fer maximaX+pas a dins del for
            llargadaN=llargadaN+1
            vector1 = [x,y,0] #creem un vector amb coordenades x, y i z (z=0)
            #Haurem d'anar comprovant aquest vector, junt amb 3 vectors vens ms, amb la matriu originial
            #i els que coincideixin els haurem d'anar afegint a la nova matriu.
            vector2 = [x+pas,y,0]
            vector3 = [x,y+pas,0]
            vector4 = [x+pas,y+pas,0]
            #Ara hem de comprovar si aquests vectors es troben dins de la matriu. Si s aix haurem d'omplir
            #el vector triangulaci amb un "1" a la posici corresponent[1,2,3,4]
            #La Matriu que passem a la funci Existeix_Vertex_Boca s on tenim tots els punt que formen la nostra boca
            if (Existeix_Vertex_Boca(matriu_interior,x,y,0)=="True"):
                #Voldr dir que el vector 1 es troba a dins a la nostra boca
                a=1
            else: a=0
            if (Existeix_Vertex_Boca(matriu_interior,x+pas,y,0)=="True"):
                #Voldr dir que el vector 2 es trboa a dins a la nostra boca
                b=1
            else: b=0
            if (Existeix_Vertex_Boca(matriu_interior,x,y+pas,0)=="True"):
                #Voldr dir que el vector 3 es troba a dins a la nostra boca
                c=1
            else: c=0
            if (Existeix_Vertex_Boca(matriu_interior,x+pas,y+pas,0)=="True"):
                #Voldr dir que el vector 4 es troba a dins a la nostra boca
                d=1
            else: d=0
            Area_Triangulacio=[a,b,c,d]
            #Ara ja tenim el vector Area_Triangulacio omplert amb 0's i 1's.
            #Ara hem de comprovar que Area_Triangulacio cont algun 1.
            #Si s aix haurem de guardar els vector1, vector2, vector3 i vector4
            
            if (Hi_Ha_Uns_Vector(Area_Triangulacio)>0):
                #Aix voldr dir que aquests 4 vectors els haurem de guardar a dins la nova matriu
                #Perqu algun d'aquests 4 vectors es troben a dins de la nostra boca del reflector.
                #Podem mirar si hi ha intersecci abans d'insertar-los a la matriu i aix,
                #d'aquesta manera ja podrem insertar-los a la posicio correcte, s a dir,
                #dins la boca del reflector.
                
                #---------- FALTA: mirar interseccio horitzontal i vertical -------------------
                Interseccions(vector1,vector2,vector3,vector4,matriu_contorn,matriu_interior,Punts_Triangulacio,Area_Triangulacio,Trident,Llista_Triangles)                                
                
            posi=posi+1
            print "Posicio principal: ",posi
            #Fins aqu anem entrant els vectors dins a Punts_Triangulacio

    #Aqu s on sortim del "FOR general". En aquests moments haurem de tenir a dins els Punts_Triangulacio
    #Els vectors els quals farem la triangulaci. Per NO HI TENIM els vrtexs del GRAHAM SCAN
    #print "Punts_Triangulacio():"
    Mostrar_Matriu_Boca(Punts_Triangulacio)
    Dibuixar_Punts(Punts_Triangulacio)
    print "Llargada N= ",llargadaN
    print "Mostrem la llista de Triangles: "
    Mostrar_Llista_Triangles(Llista_Triangles)
    UnioTriangulacio(Llista_Triangles)
    print "Mostrem la matriu_interior:"
    Mostrar_Matriu_Boca(matriu_interior)
    #A la matriu Punts_Triangulaci hi ha vrtexs els quals pertanyen a l'interior de la boca i d'altres NO.
    #Per ens serveixen per fer les unions de la triangulaci.
    #Aqu dins aquesta funci tinc les 3 matrius(totes) la matriu_Graham (contorn) la matriu_copiada (interior) i
    #els punts_Triangulacio (interior i no interiors)


            
                    

#Aquesta funci ens pinta els vrtexs sobre la nostra superfcie del "BLENDER"
def Dibuixar_Punts(matriu):
    for i in range(0,matriu.fila):
        vertex=NMesh.Vert(matriu.Matriu_Vertex_Boca[i][0],matriu.Matriu_Vertex_Boca[i][1],matriu.Matriu_Vertex_Boca[i][2])
        poligon2.verts.append(vertex)



#La funcio CercarValorProxim() ens retornar un vector que s'aproximi
#al vector candidat i aix poder fer el CrossProduct en la funci
#EsTrobaDinsLaBoca(). Haurem de cridar aquesta funci CercarValorProxim
#dues vegades perqu ens retorni els dos vectors prxims al vectorcandidat
#sabrem que hem cridat dues vegades la funcio CercarValorProxim() perqu
#tindrem els vectorprox1 i vectorProx2 diferents a 0.
#La matriu s el resultat del Graham_Scan.
def CercarValorProxim(matriu,vectorcandidat):
    #El vectorcandidat t la component x i la component y, a ms de la z=0
    
    #anem a calcular la x:
    valorXpetit=abs(vectorcandidat[0] - matriu.Matriu_Vertex_Boca[0][0])
    #anem a calcular la y:
    valorYpetit=abs(vectorcandidat[1] - matriu.Matriu_Vertex_Boca[0][1])
    valormespetitsumat=valorXpetit+valorYpetit
    posicio=0
    millorcandidat="False"
    
    for i in range (1,matriu.fila):
        #anem a calcular la x:
        valorX=abs(vectorcandidat[0] - matriu.Matriu_Vertex_Boca[i][0])
        #anem a calcular la y:
        valorY=abs(vectorcandidat[1] - matriu.Matriu_Vertex_Boca[i][1])
        valorpetitsumat=valorX+valorY
        if ((valorXpetit>valorX) and (valorYpetit>valorY)):
            posicio=i
            millorcandidat="True"
            valorXpetit=valorX
            valorYpetit=valorY
        elif((valormespetitsumat>valorpetitsumat) and (millorcandidat=="False")):
        #elif ((valorYpetit>valorY) and (millorcandidat=="False")):
            valormespetitsumat=valorpetitsumat
            #valorYpetit=valorY
            posicio=i

    return(posicio)
                

            
def CercarValorProxim2(matriu,vectorcandidat,posicio1):
    #El vectorcandidat t la component x i la component y, a ms de la z=0

    j=0
    if (j==posicio1):
        j=j+1
    
    #anem a calcular la x:
    valorXpetit=abs(vectorcandidat[0] - matriu.Matriu_Vertex_Boca[j][0])
    #anem a calcular la y:
    valorYpetit=abs(vectorcandidat[1] - matriu.Matriu_Vertex_Boca[j][1])
    valormespetitsumat=valorXpetit+valorYpetit
    posicio=j
    j=j+1
    millorcandidat="False"
    
    for i in range (j,matriu.fila):

        #anem a calcular la x:
        valorX=abs(vectorcandidat[0] - matriu.Matriu_Vertex_Boca[i][0])
        #anem a calcular la y:
        valorY=abs(vectorcandidat[1] - matriu.Matriu_Vertex_Boca[i][1])
        valorpetitsumat=valorX+valorY
        if ((valorXpetit>valorX) and (valorYpetit>valorY) and (i<>posicio1)):
            posicio=i
            millorcandidat="True"
            valorXpetit=valorX
            valorYpetit=valorY
        elif ((valormespetitsumat>valorpetitsumat) and (millorcandidat=="False") and (i <> posicio1)):
        #elif ((valorYpetit>valorY) and (millorcandidat=="False")):
            valormespetitsumat=valorpetitsumat
            #valorYpetit=valorY
            posicio=i

    return(posicio)


#La funci EsTrobaDinsLaBoca() retorna cert o fals segons si el punt
#que volem inserir es situar a l'interior de la nostra boca
#del reflector o no, respectivament.
#La matriu que li passem s la matriu resultant del Graham_Scan
#El vector s el vector s el punt candidat a inserir
#def EsTrobaDinsLaBoca(matriu,vector):

        


#Li passem la matriu acabada de crear amb el Graham_Scan perqu tindrem
#les mnimes i les mximes de les X's i de les Y's.
#A ms podrem saber si els punts que insertem es troben a l'interior o
#a l'exterior de la boca utilitzant la funcio Cross_Product perqu
#s capa  de dir-nos si els punts es troben a l'esquerra o a la dreta
#de dos punts. Els punts els creem no alleatriament.
def CrearPuntsInteriors(matriu):

    
    #La variable pas s l'increment que fa el bucle del for
    # per defecte anir a pas 1.
    #necessitem una matriu nova per passar-hi els punts interiors
    matriu_nova = Matriu_Nova()
    pas= 20
    maximaY = int(Ymax(matriu))
    maximaX = int(Xmax(matriu))
    minimaY = int(Ymin(matriu))
    minimaX = int(Xmin(matriu))
    maxfila=matriu.fila-1
    

    #limitem la nostra rea segons un quadrat (els punts sern vectors)

    #Limit_Esq_Sota         part esquerra inferior
    #Limit_Esq_Sobre        part esquerra superior
    #Limit_Dreta_Sota       part dreta inferior
    #Limit_Dreta_Sobre      part dreta superior

    Limit_Esq_Sota= [minimaX, minimaY, 0]
    Limit_Esq_Sobre = [minimaX, maximaY, 0]
    Limit_Dreta_Sota = [maximaX, minimaY, 0]
    Limit_Dreta_Sobre = [maximaX, maximaY, 0]

##    print "Limit Dreta Sota: ", Limit_Dreta_Sota
##    print "Limit Dreta Sobre: ",Limit_Dreta_Sobre
##    print "Limit Esquerra Sota: ",Limit_Esq_Sota
##    print "Limit Esquerra Sobre: ",Limit_Esq_Sobre
    #Els lmits em serviaran per saber si els punts es troben a dins o
    # a fora de la nostra boca, juntament amb la funci Cross_Product.
    for y in range(minimaY, maximaY, pas):
        for x in range(minimaX, maximaX, pas):
            vector = [x,y,0] #creem un vector amb coordenades x, y i z (z=0)
        
            #ara mirem si el podem crear
            #la variable posicio contindr la podici del vector de la matriu ms prxim
            #al vectorcandidat
            posicio1=CercarValorProxim(matriu,vector)
            #un cop tenim un vector prxim al vector candidat ens caldr trobar un segon vector
            #i aix podrem fer el crossproduct i saber si es troba a l'esquerra o a la dreta del
            #nostre vector candidat.
            posicio2=CercarValorProxim2(matriu,vector,posicio1)
            
            #Ara hem de saber quina posici de les dues s ms petita perqu sempre anem en la
            #direcci contrria del rellotge. Noms tindrem problemes quan una de les dues posicions
            #sigui zero i l'altre sigui l'ltim element de la nostra matriu.
            
            if (posicio1>posicio2):
                temp=posicio1
                posicio1=posicio2
                posicio2=temp
                #ara ja tinc el mes petit a la posicio1
            if (posicio1==0 and posicio2==maxfila):#hem de tenir en compte l'ultim element i el zero
                temp=posicio1
                posicio1=posicio2
                posicio2=temp
            
            o = Cross_Product(matriu.Matriu_Vertex_Boca[posicio1], matriu.Matriu_Vertex_Boca[posicio2],vector)
            #amb el resultat del CrossProduct sabrem si el vector es troba a la dreta o a l'esquerra de la lnia
            #i per tant sabrem si es troba a l'interior de la nostra boca o a fora.

            if (o>0):   #vol dir que el vertex es troba a la part interior de la nostra boca i per tant
                #l'haurem d'afegir a la nostra matriu
                if (Existeix_Vertex_Boca(matriu,vector[0],vector[1],vector[2])=="False"):
                    #si ens retorna fals vol dir que no existeix aquest vector a la nostra matriu i
                    #per tant l'haurem d'afegir.
                    #vector[0]=component X
                    #vector[1]=component y
                    #vector[2]=component z
                    Crear_Matriu_Boca(matriu_nova,vector[0],vector[1],vector[2])
                    #Hem de dibuixar aquest vrtex al nostre polgon
                    vertex = NMesh.Vert(vector[0],vector[1],vector[2])
                    #Afegim el vertex que hem creat al nostre polgon
                    poligon.verts.append(vertex)
##                    print "Insertarem el vector"
    #finalment hem d'unir les dues matrius: matriu_nova i matriu (on matriu=matriu_graham)
    #maxfila cont el numero de files de la matriu_graham (la inicial)
    maxfila=maxfila+1
    maxfilamatriunova= matriu_nova.fila
    for i in range (0,maxfilamatriunova):
        vector=[matriu_nova.Matriu_Vertex_Boca[i][0],matriu_nova.Matriu_Vertex_Boca[i][1],matriu_nova.Matriu_Vertex_Boca[i][2]]
        if (Existeix_Vertex_Boca(matriu, vector[0], vector[1], vector[2])=="False"):
            Crear_Matriu_Boca(matriu, vector[0], vector[1], vector[2])
            
            


def Swap(i,j,matriu):
    temp = 0
    #canviem les x:
##    print "swap %d,%d" %(matriu.Matriu_Vertex_Boca[i][0], matriu.Matriu_Vertex_Boca[j][0])
    #SWAP (temp, matriu.Matriu_Vertex_Boca[i][0], matriu.Matriu_Vertex_Boca[j][0])
    temp = matriu.Matriu_Vertex_Boca[i][0]
    matriu.Matriu_Vertex_Boca[i][0] = matriu.Matriu_Vertex_Boca[j][0]
    matriu.Matriu_Vertex_Boca[j][0] = temp
    #canviem les Y:
##    print "swap %d,%d" %(matriu.Matriu_Vertex_Boca[i][1], matriu.Matriu_Vertex_Boca[j][1])
    #SWAP (temp, matriu.Matriu_Vertex_Boca[i][1], matriu.Matriu_Vertex_Boca[j][1])
    temp = matriu.Matriu_Vertex_Boca[i][1]
    matriu.Matriu_Vertex_Boca[i][1] = matriu.Matriu_Vertex_Boca[j][1]
    matriu.Matriu_Vertex_Boca[j][1] = temp
    #canviem les Z:
##    print "swap %d,%d" %(matriu.Matriu_Vertex_Boca[i][2], matriu.Matriu_Vertex_Boca[j][2])
    #SWAP (temp, matriu.Matriu_Vertex_Boca[i][2], matriu.Matriu_Vertex_Boca[j][2])
    temp = matriu.Matriu_Vertex_Boca[i][2]
    matriu.Matriu_Vertex_Boca[i][2] = matriu.Matriu_Vertex_Boca[j][2]
    matriu.Matriu_Vertex_Boca[j][2] = temp

# ------------------------------------------- #
# FindLowest finds the rightmost lowest point and swaps with 0-th.
# The lowest point has the min y-coord, 
# Si hi ha empat, el candidat ser el que t la X ms petita.

def FindLowest(matriu):

    #La variable "Matriu_Boca" cont la matriu 'global'
    n=matriu.fila
    m=0
    i=1
    # "n" s la variable que cont el nmero de files de la matriu, s a dir, cont
    # el nmero de vrtex que cont la boca.
    for i in range (1,n):
        #Primer mirem la coordenada Y:
        if (matriu.Matriu_Vertex_Boca[i][1] < matriu.Matriu_Vertex_Boca[m][1]):
##            print "Swapping %d with 0\n" %(i)
            Swap(0,i,matriu)#Swap Matriu_Boca.Matriu_Vertex_Boca[0] Matriu_Boca.Matriu_Vertex_Boca[i]
        else:
            if (matriu.Matriu_Vertex_Boca[i][1] == matriu.Matriu_Vertex_Boca[m][1]):
                #Ara mirem la coordenada X perqu hi ha hagut empat amb les Y's:
                if (matriu.Matriu_Vertex_Boca[i][0] < matriu.Matriu_Vertex_Boca[m][0]):
##                    print "Swapping %d with 0\n" %(i)
                    Swap(0,i,matriu)#Swap Matriu_Boca.Matriu_Vertex_Boca[0] Matriu_Boca.Matriu_Vertex_Boca[i]
                else:
                    #Si arribem aqu voldr dir que la fila "m" s ms petita que la fila "i" (coordenada X)
##                    print "Swapping %d with 0\n" %(m)
                    Swap(0,m,matriu)#Swap Matriu_Boca.Matriu_Vertex_Boca[0] Matriu_Boca.Matriu_Vertex_Boca[m]
        


#El catetOposat seria la Y
#El clcul el fem a partir de dos punts, s a dir, a partir de dos vectors
def CalcCatetOposat(Vector_A, Vector_B):
    max_Y= max(Vector_A[1], Vector_B[1])

    if (Vector_A[1] == max_Y):
        Costat_Oposat = (Vector_A[1] - Vector_B[1])
    elif (Vector_B[1] == max_Y):
        Costat_Oposat = (Vector_B[1] - Vector_A[1])

    return (Costat_Oposat)

#El catetAdjacent seria la X
#El clcul el fem a partir de dos punts, s a dir, a partir de dos vectors
def CalcCatetAdjacent(Vector_A, Vector_B):

    max_X = max(Vector_A[0], Vector_B[0])

    if (Vector_A[0] == max_X):
        Costat_Adjacent = (Vector_A[0] - Vector_B[0])
    elif(Vector_B[0] == max_X):
        Costat_Adjacent = (Vector_B[0] - Vector_A[0])

    return (Costat_Adjacent)


# La funci tangent ens retorna el valor de la tangent que forma el triangle format pels 3punts A,B,C
# Ens retorna l'angle que forma A amb B i C.
# D'aquesta manera podem comprovar quin angle s el ms petit que tenim en la matriu.
# Noms ens cal calcular la tangent, no ens fa falta l'angle.
def Tangent(X, Y):

    #CatetAdjacent = CalcCatetAdjacent(Vector_A, Vector_B)
    #CatetOposat = CalcCatetOposat(Vector_A, Vector_B)
    Tang = Y / X
    return (Tang)


#La funci Atan ens retorna l'arctangent de l'angle format per dos punts o (dos vectors)
#L'arctangent s la inversa de la tangent
def Atan(X, Y):
    resultat = atan(Tangent(X,Y))#La funci atan ja est definida a la classe "math"
    #retorna la inversa de la tangent

    return (resultat)

    


#Hem de calcular l'angle que formen els nostres vectors (donat 2 punts)
#Aquest angle ens pot causar problemes perqu podem tenir un vector en un quadrant
#i el segon vector en un quadrant diferent.
def polarAngle(X,Y):
    #x -> [0]
    #y -> [1]
    #z -> [2]
    
    #Hipotticament s difcil trobar una X=0 i una Y=0
    if (X == 0) and (Y == 0):
        return (-1)
    if (X == 0):
        if (Y>0):
            return (90)
        elif (Y<=0):
            return (270)
    theta = Atan(X,Y)
    theta = theta * (360/(2*pi)) #pi s una constant declarada a la llibreria math
    if (X>0):
        if (Y>=0):
            return(theta)
        elif (Y<0): return (theta + 360)
    elif (X<=0): return(theta + 180)


#PER CALCULAR LA TANGENT I L'ANGLE POLAR O LA ARCTANGENT ENS FALTA EL PUNT MNIM I QUALSEVOL DELS
#ALTRES PUNTS QUE FORMEN EL NOSTRE NBOL DE PUNTS.
#CADASCN D'ELLS TINDR UN VALOR CORRESPONENT A LA SEVA TANGENT.
#NO S NECESSARI DESCART CAP PUNT; ENCARA NO DESCARTEM PUNTS PER A LA NOSTRA MATRIU RESULTANT.
#comparem els angles dels dos vectors
#Returnarem el valor del seu angle
def PolarComp(Vector_A, Vector_B):
#El vector A sempre ser el vector amb y ms petita!!
  
    X = Vector_B[0] - Vector_A[0]
    Y = Vector_B[1] - Vector_A[1]

    #Ara tenim un valor a X i un altre a Y

    resultat = polarAngle(X,Y)
    return (resultat)
    
    
    

############################################
################# TRIANGLES ################
############################################
#La funci Crear_Triangle() ens va creant un triangle de mica en mica i sabrem que aquest est ple
#perqu la seva posicio haur arribat a "2" Desprs el podrem insertar dins la llista de Triangles
def Crear_Triangle(trident,numero):
    #La posicio del trident tamb ens diu quants vrtexs hem entrat en aquest triangle
    print "Entrem dins Crear_Triangle."
    print "trident.posicio= ",trident.posicio
    if (trident.posicio==0):
        trident.vertexs[0]=numero
        trident.posicio +=1
    elif (trident.posicio==1):
        trident.vertexs[1]=numero
        trident.posicio +=1
    elif (trident.posicio==2):
        trident.vertexs[2]=numero
        trident.posicio +=1


#############################################
########### LLISTA DE TRIANGLES #############
#############################################
#En realitat aquesta funci crea una matriu amb la quantitat
#de triangles que haurem d'unir. Els triangles els unirem en vrtexs de tres en tres
#entrerem els vrtexs d'en un en un i a mesura que anem omplint les tres posicions,
#abanarem de fila (o posicio)
def Crear_Llista_Triangles (llista,trident):
    #nombre s la posici que pren el vrtexs dins la llista de vrtexs del poligon
    #El triden quan arriba aqu ja ha de tenir les seves 3 posicions plenes
    print "Trident: ",trident.posicio," ",trident.vertexs[0]
    print "Trident: ",trident.posicio," ",trident.vertexs[1]
    print "Trident: ",trident.posicio," ",trident.vertexs[2]
    if (llista.fila==0):
        llista.Matriu_Vertex_Boca[0][0]=trident.vertexs[0]
        llista.Matriu_Vertex_Boca[0][1]=trident.vertexs[1]
        llista.Matriu_Vertex_Boca[0][2]=trident.vertexs[2]
    else:
        a=[trident.vertexs[0],trident.vertexs[1],trident.vertexs[2]]
        llista.Matriu_Vertex_Boca.append(a) #S'ha de fer primer amb append sin aix dna un error
        llista.Matriu_Vertex_Boca[llista.fila][0]=trident.vertexs[0]
        llista.Matriu_Vertex_Boca[llista.fila][1]=trident.vertexs[1]
        llista.Matriu_Vertex_Boca[llista.fila][2]=trident.vertexs[2]
    llista.fila +=1


    

def Afegir_Triangle_Llista(llista,trident):

    print "Afegir Triangle Llista: "
    print "Trident.posicio= ", trident.posicio
    if (trident.posicio==3):
        Crear_Llista_Triangles(llista,trident)
        trident.posicio=0


def Mostrar_Llista_Triangles(llista):

    for i in range (0,llista.fila):
        print "Triangle Num[",i,"]: ",llista.Matriu_Vertex_Boca[i],"."

############################################
########### MATRIU_VERTEX_BOCA #############
############################################

#Necessitem unir els vrtex de la boca i per aix hem de reordanar la nostra matriu
#La funci ordena els valors segons la tangent que obtenim a partir del primer element de la matriu.
#La matriu ja est ordenada amb l'element ms petit a la primera posici.
def Preparar_Unio_De_Vertex(matriu):

    #El vrtex ms petit el tenim situat a la primera posici de la matriu.
    LowestPoint = [[0,0,0]]
    LowestTangent = round(float(0),8)
    LowTangnet = round(float(0),8)
    LowestPosition = 0
    IndexOrdenat=0 #La variable i s la que ens donar la posici del vrtex que estem calculant (fa de ndex per a la ordenaci).
    
    NombreTotalVertex = matriu.fila
    #L'indexOrdenat ens indica que de moment l'nic vector ordenat s el de la posici 0 de la matriu, perqu
    #s el que t el valor de la coordenada "y" ms petit.    

    for i in range(1,NombreTotalVertex):#em sembla que va (NombreTotalVertex -1)
        LowestTangent= PolarComp(matriu.Matriu_Vertex_Boca[0],matriu.Matriu_Vertex_Boca[i])
        LowestTangent = round(float(LowestTangent),8)
##        print "LowestTangent: ", LowestTangent
        LowestPosition = i
        for j in range(i+1,NombreTotalVertex):
            LowTangent = PolarComp(matriu.Matriu_Vertex_Boca[0],matriu.Matriu_Vertex_Boca[j])
            LowTangent = round(float(LowTangent),8)
##            print "LowTangent: ", LowTangent
            if (LowTangent < LowestTangent):
                LowestTangent = LowTangent
                LowestPosition = j
##        print "LowestPosition: ",LowestPosition
        Swap(i,LowestPosition,matriu)


#Unirem tots els vrtexs de la nostra matriu aix formarem la boca del reflector
#Els vrtexs estaran units per les seves corresponents lnies.
def Realitzar_Unio_De_Vertex(matriu):
##    print "Numero de vertex:", matriu.fila

##    for i in range(0, matriu.fila):
##        print "poligon.verts: " , poligon.verts[i]
##        print "poligon.verts[(i)%(Matriu_Boca.fila-1)]: ", poligon.verts[(i)%(matriu.fila-1)]
##    print "poligon.verts[Matriu_Boca.fila-1]: ", poligon.verts[matriu.fila-1]
        

    
    for i in range (0,matriu.fila-1):
        cara = NMesh.Face()
        cara.append(poligon.verts[matriu.fila-1])
        cara.append(poligon.verts[i])
        cara.append(poligon.verts[i+1])
        poligon.faces.append(cara)

  
   
    
#Afegim una fila a la nostra matriu
def Crear_Matriu_Boca(matriu,punt1,punt2,punt3):
    #Si la fila s igual a zero vol dir que encara no hem entrat cap vertex i
    #noms tenim inicialitzada la matriu amb valors "zero"
    if (matriu.fila==0):
        matriu.Matriu_Vertex_Boca[0][0]=punt1
        matriu.Matriu_Vertex_Boca[0][1]=punt2
        matriu.Matriu_Vertex_Boca[0][2]=punt3
    else:
        a=[punt1,punt2,punt3]
        matriu.Matriu_Vertex_Boca.append(a) #S'ha de fer primer amb append sin aix dna un error
        matriu.Matriu_Vertex_Boca[matriu.fila][0]=punt1
        matriu.Matriu_Vertex_Boca[matriu.fila][1]=punt2
        matriu.Matriu_Vertex_Boca[matriu.fila][2]=punt3
    matriu.fila +=1

   
#Aquesta funci hi entrarem una "posicio" i ens retornar la posicio real que ocupa el vrtex en la nostra matriu
def Mostrar_Matriu_Posicio(matriu,posicio):

    resultat="NULL"
    i=0
    while (i<matriu.fila):
        if (posicio==matriu.Matriu_Vertex_Boca[i][3]):
            resultat=i
            break
        i=i+1
    return(resultat)

#La funci Buscar_Posicio ens retorna el lloc del vrtexs dins la matriu.
#Sabem del cert que el vrtex es troba dins de la matriu
def Buscar_Posicio(matriu,vertex):

    i=0
    resultat=-1 #Si tot va b s impossible que el -1 arribi com a resultat final
    #perqu ja hem comprovat que el vrtex es troba dins de la matriu
    while (i<matriu.fila):
        if (vertex[0]==matriu.Matriu_Vertex_Boca[i][0]):
            if (vertex[1]==matriu.Matriu_Vertex_Boca[i][1]):
                if (vertex[2]==matriu.Matriu_Vertex_Boca[i][2]):
                    resultat=i
                    break
        i +=1
      
            
    return(resultat)

#Aquesta funci ens mostra la matriu
#Podem veure els vertex que cont la boca del reflector
def Mostrar_Matriu_Boca(matriu):
    i=0
    j=0
    for i in range(matriu.fila):
        for j in range (3):
            print "posicio ", i,j, ": ", matriu.Matriu_Vertex_Boca[i][j],"."
        

#La funci Comprovar_Vertex_Boca fa una cerca del vrtex que volem entrar.
#si el vrtex es troba a dins la matriu la funci ens returnar "cert",
# en cas contrari, la funci ens retornar "fals".
def Existeix_Vertex_Boca(matriu,punt1,punt2,punt3):
    #print "Comprovem si existeix el vertex"
    i=0
    pertany = "False"
    if (matriu.fila <> 0):
        for i in range(matriu.fila):
            if (matriu.Matriu_Vertex_Boca[i][0] == punt1):
                if (matriu.Matriu_Vertex_Boca[i][1] == punt2):
                    if (matriu.Matriu_Vertex_Boca[i][2] == punt3):
                        #print "El vrtex SI EXISTEIX"
                        pertany = "True"
                        #print "el vertex repetit es: x=", punt1, " y=",punt2, " z=",punt3
                        #pausa= raw_input('pausa: ')
                        break
        
    return (pertany)

  
##############################################
##############################################


#############################################
############## BOUNDING BOX  ################
#############################################
#volem buscar el centre de la boca del reflector
# El Bounding BOX s el punt geomtric del nostre objecte
# ((minX + maxX)/2) i ((minY + maxY)/2)
def setBoundingBox(matriu):
    #########################
    ## Matriu_Vertex_Boca: ##
    ##   | X | Y | Z |     ##
    ##   |   |   |   |     ##
    ##   | . | . | . |     ##
    #########################
    #Haurem de crear una altra matriu on hi collocarem
    # els vrtexs que l'usuari podr moure, s a dir,
    # els vrtexs que correspondrn a l'interior de la boca.

    #Variables que utilitzarem : minX, minY, MaxX, MaxY    
    #Les files que haurem de recrrer per a buscar els mnims i els mxims
    # els trobarem a Matriu_Vertex_Boca.fila (de 0 fins a Matriu_Vertex_Boca.fila)

    i = 0
    minX = matriu.Matriu_Vertex_Boca[0][0]
    minY = matriu.Matriu_Vertex_Boca[0][1]
    MaxX = matriu.Matriu_Vertex_Boca[0][0]
    MaxY = matriu.Matriu_Vertex_Boca[0][1]
    BoundingX = 0
    BoundingY = 0
    BoundingZ = 0.0
    for i in range (matriu.fila):
        #Mnim de X:
        minX = min (minX, matriu.Matriu_Vertex_Boca[i][0])
        #Mxim de X:
        MaxX = max (MaxX, matriu.Matriu_Vertex_Boca[i][0])
        #Mnim de Y:
        minY = min (minY, matriu.Matriu_Vertex_Boca[i][1])
        #Mxim de Y:
        MaxY = max (MaxY, matriu.Matriu_Vertex_Boca[i][1])
    #Ara ja tinc els mxims i mnims de Y i de X
    #Ara noms em cal fer la operaci:
    BoundingX = ((minX + MaxX)/2)
    BoundingY = ((minY + MaxY)/2)
    BoundingX = round(BoundingX,6)
    BoundingY = round(BoundingY,6)
    
   
    return (BoundingX,BoundingY)
###########################################
###########################################

###########################################
###### OMPLIR LA BOCA DE VRTEXS ##########
###########################################
#Aquesta funci simplement ens retorna cert o fals depenent de si els vrtex entrats sn iguals o no.
#Fa la comparaci de dos punts.
def Iguals_Vertex(Vertex1_X,Vertex1_Y,Vertex2_X,Vertex2_Y):
    # 0 = fals
    # 1 = cert
    igualtat = 0
    #Comparem les X's
    if (Vertex1_X == Vertex2_X):
        #Comparem les Y's
        if (Vertex1_Y == Vertex2_Y):
            igualtat = 1

    return (igualtat)        


#Aquesta funci el qu fa s recrrer tota la matriu per afegir el nombre de vrtexs per lnia
#que volem que tingui el nostre reflector
def Afegir_Vertexs_Interiors(nombre,matriu,CentreX,CentreY):

    for i in range(matriu.fila):
        if (Iguals_Vertex(matriu.Matriu_Vertex_Boca[i][0],matriu.Matriu_Vertex_Boca[i][1],CentreX,CentreY) == 0):
            #Els vrtexs sn diferents
            #Ara buscarem les x grans i petites dels dos vertexs (amb les y farem el mateix):
            granX = max(matriu.Matriu_Vertex_Boca[i][0], CentreX)
            petitX = min(matriu.Matriu_Vertex_Boca[i][0], CentreX)
            granY = max(matriu.Matriu_Vertex_Boca[i][1], CentreY)
            petitY = min(matriu.Matriu_Vertex_Boca[i][1], CentreY)

            LongitudX = granX - petitX
            LongitudY = granY - petitY

            TrocetsX = round((LongitudX / nombre),6)
            TrocetsY = round((LongitudY / nombre),6)

            #Ara hem d'afegir aquests trocets a partir del vector original:
            j=1;
            while (j < nombre):
                if (matriu.Matriu_Vertex_Boca[i][0] == granX):
                    X= (matriu.Matriu_Vertex_Boca[i][0] - (TrocetsX*j))
                else:
                    if (matriu.Matriu_Vertex_Boca[i][0] == petitX):
                        X= (matriu.Matriu_Vertex_Boca[i][0] + (TrocetsX*j))
                if (matriu.Matriu_Vertex_Boca[i][1] == granY):
                    Y= (matriu.Matriu_Vertex_Boca[i][1] - (TrocetsY*j))
                else:
                    if (matriu.Matriu_Vertex_Boca[i][1] == petitY):
                        Y= (matriu.Matriu_Vertex_Boca[i][1] + (TrocetsY*j))
                #Ara ja tinc un altre vrtex, noms cal ficar-lo a la matriu i dibuixar-lo al Blender
                Z=0
                #No cal comprovar si el punt existeix a dins la matriu perqu segur que no s'hi troba.
                Crear_Matriu_Boca(matriu,X,Y,Z)
                #Hem de dibuixar aquest vrtex al nostre polgon
                vertex = NMesh.Vert(X,Y,Z)
                #Afegim el vertex que hem creat al nostre polgon
                poligon.verts.append(vertex)
                j=j+1
            
                
            
            
        
    



################################################
################################################
################################################

            
#Aquesta funci construeix el nostre reflector:
#def reflector(mesh):
#Aquesta funci dibuixar les lnees del reflector (d'una en una)
#Dibuixa una lnia a partir de dos punts (per encara no els uneix)
def Creem_Vertex(p0, p1):
    #com que ja tenim el "Mesh" creat amb la funci NMesh.GetRaw()
    #ara noms ens cal indicar-li els vrtex
    #per tant creem el vrtex:
    
    #Necessitem l'arroduniment del punt on es troba situat el vrtex.
    #Com menys decimals agafem, despreciarem ms punts de la nostra matriu.
    punt1=round(float(p0[0]),6) #La funci float ja est "pre-definida" i converteix el nombre a REAL
    punt2=round(float(p0[1]),6)
    punt3=round(float(p0[2]),6)

    #comprovem si el vrtex existeix dins la nostra matriu de la boca:
    if (Existeix_Vertex_Boca(Matriu_Boca,punt1,punt2,punt3) == "False"):
##        print "El vertex NO EXISTEIX"
        #Construim la matriu:
        Crear_Matriu_Boca(Matriu_Boca,punt1,punt2,punt3)
        vertex = NMesh.Vert(punt1,punt2,punt3)
        #Afegim el vertex que hem creat al nostre polgon
        poligon.verts.append(vertex)

    punt1=round(float(p1[0]),6)
    punt2=round(float(p1[1]),6)
    punt3=round(float(p1[2]),6)

    #Comprovem si el vrtex existeix dins la nostra matriu de la boca:
    if (Existeix_Vertex_Boca(Matriu_Boca,punt1,punt2,punt3) == "False"):
##        print "El vertex NO EXISTEIX"
        #Construim la matriu:
        Crear_Matriu_Boca(Matriu_Boca,punt1,punt2,punt3)
        vertex = NMesh.Vert(punt1,punt2,punt3)
        #Afegim el vertex que hem creat al nostre polgon
        poligon.verts.append(vertex)


#Aquesta funci tractar els "ARCS"
def processArcEntity(filename):
##    print "Entrem dins el processArcEntity"
    p0=[0,0,0]
    p1=[0,0,0]
    Center=[0,0,0]
    file = filename
    Llegim_Parell_linies(file)
    print linea
    while (GroupCode != "0"): #Read Until the beginning of the next entity
        if (GroupCode == "8"):
##            print "Hem entrat dins GROUPCODE 8"
            #if (linea.rstrip()== Layer):
            Layer = linea
##            print "el nom de la capa es", Layer
            RightLayer=0 #el zero vol dir cert!!!
            #break
        elif (GroupCode == "10"):
            #center[0]
##            print "Hem entrat dins GROUPCODE 10"
            Center[0] = float(linea)
            print Center[0]
            #break
        elif (GroupCode == "20"):
            #center[1]
##            print "Hem entrat dins GROUPCODE 20"
            Center[1] = float(linea)
            print Center[1]
            #break
        elif (GroupCode == "30"):
            #center[2]
##            print "Hem entrat dins GROUPCODE 30"
            Center[2] = float(linea)
            print Center[2]
            #break
        elif (GroupCode == "40"):
            #radius
##            print "Hem entrat dins GROUPCODE 40"
            #Aquest punt s el tamany del radi
            #de moment no el farem servir.
            Radius = float(linea)
            print Radius
            #break
        elif (GroupCode == "50"):
            #StartAngle
##            print "Hem entrat dins GROUPCODE 50"
            #Aqu en aquest punt comena l'arc
            StartAngle = float(linea)
            print StartAngle
            #break
        elif (GroupCode == "51"):
            #EndAngle
##            print "Hem entrat dins GROUPCODE 51"
            #Aquest punt s on acaba l'arc
            EndAngle = float(linea)
            print EndAngle
            #break
        else:
            print ".",GroupCode, ",", linea,"."
            #break

        Llegim_Parell_linies(file)
        
##    print "Hem sortiT del bucle perque el GROUPCODE s un ZERO"

    #Els vrtex que trobo a continuaci sn el vrtex inicial de l'arc i el vrtex final de l'arc    
    p0[0]= Radius*cos(StartAngle / 180.0*pi)+Center[0]
    p0[1]= Radius*sin(StartAngle / 180.0*pi)+Center[1]
    p1[0]= Radius*cos(EndAngle / 180.0*pi)+Center[0]
    p1[1]= Radius*sin(EndAngle / 180.0*pi)+Center[1]
    p0[2]=float(0)
    p1[2]=float(0)
    #Em faltaria un tercer vrtex per aconseguir la corba.
    
    if (RightLayer == 0):
        #creem un vertex
        Creem_Vertex(p0,p1)
##        print "Hem creat un VERTEX"
    
##    print "Ara sortim de la funci PROCESSARCENTITY"
    

#Aquesta funci tractar les linies "LINES"
def processLineEntity(filename):
##    print "Entrem dins el processLineEntity"
    #creem el nostre vector 3D, per tant tindr tres posicions (ser nul)
    p0=[0,0,0]
    p1=[0,0,0]
    file = filename
    #filemon = open(filename, "rb")
    RightLineType="true"
    RightLayer=1
    Llegim_Parell_linies(file)
    print linea
    while (GroupCode != "0"): #Read Until the beginning of the next entity
        if (GroupCode == "8"):
##            print "Hem entrat dins GROUPCODE 8"
            #if (linea.rstrip()== Layer):
            RightLayer=0 #el zero vol dir cert!!!
            #break
        elif (GroupCode == "6"):
            if (linea!="DASHDOT"):
##                print "Hem entrat dins GROUPCODE 6 DASHDOT"
                RightLineType="true"
                #break
        elif (GroupCode == "10"):
##            print "Hem entrat dins GROUPCODE 10"
            p0[0] = linea
            #break
        elif (GroupCode == "20"):
##            print "Hem entrat dins GROUPCODE 20"
            p0[1] = linea
            #break
        elif (GroupCode == "30"):
##            print "Hem entrat dins GROUPCODE 30"
            p0[2] = linea
            #break
        elif (GroupCode == "11"):
##            print "Hem entrat dins GROUPCODE 11"
            p1[0] = linea
            #break
        elif (GroupCode == "21"):
##            print "Hem entrat dins GROUPCODE 21"
            p1[1] = linea
            #break
        elif (GroupCode == "31"):
##            print "Hem entrat dins GROUPCODE 31"
            p1[2] = linea
            #break
        else:
            print ".",GroupCode, ",", linea,"."
            #break

        Llegim_Parell_linies(file)
        
##    print "Hem sortiT del bucle perque el GROUPCODE s un ZERO"
    


    if ((RightLayer == 0) and (RightLineType == "true")):
        #creem un vertex.
        Creem_Vertex(p0,p1)
##        print "Hem creat un VERTEX"

##    print "Ara sortim de la funci PROCESSLINEENTITY"
    
#Aquesta funci s'encarrega de moure tots els punts a la posici zero,zero,zero.
#d'aquesta manera quan creem l'objecte se'ns crear al centre del nostre "mesh"
#L'objecte ens quedar a la posicio: (0,0,0)
def Translacio_Matriu(matriu):

    matriutemporal=Matriu_Temporal()
    
    maxY=Ymax(matriu)
    minY=Ymin(matriu)
    maxX=Xmax(matriu)
    minX=Xmin(matriu)
    
    for i in range (0,matriu.fila):
        vertx=matriu.Matriu_Vertex_Boca[i][0]-((maxX+minX)/2)
        verty=matriu.Matriu_Vertex_Boca[i][1]-((maxY+minY)/2)
        vertz=0
        Crear_Matriu_Boca(matriutemporal,vertx,verty,vertz)

    Natejar_Matriu(matriu)
    Copiar_Matrius(matriutemporal,matriu)


#Aquesta funci carrega el fitxer DXF:
def Load_DXF(filename):

    global objecte2, objecte
    global maximaY,maximaX,minimaY,minimaX #Ens serveixen per crear el pl 
    global file
    #Aquesta matriu ens serveix per entrar els vrtex que creem per a la boca.
    #D'aquesta manera evitarem vrtex repatits.
    global Matriu_Boca 
    #Aquesta matriu s la matriu que obtindrem desprs d'aplicar l'algorisme "Graham_Scan".
    global Matriu_Graham
    vectorcandidat=[0,0,0]

    # Creem la matriu n*3 on n s el nmero de files i 3 el nmero de columnes.
    #########################
    ## Matriu_Vertex_Boca: ##
    ##   | X | Y | Z |     ##
    ##   |   |   |   |     ##
    ##   | . | . | . |     ##
    #########################

    Matriu_Boca = Matriu_Boca()
    Matriu_Graham = Matriu_Graham()
    
    index=0 #Aquest index ens situar a la lnia del fitxer que hem llegit.
    time1 = Blender.sys.time() #return a float representing UTC time in seconds since the epoch.
    file = open(filename, "r")
        #Returns a new file object. filename is the file name to be opened. mode indicates how the file is to be opened:
		#'r' for reading 
		#'w' for writing (truncating an existing file) 
		#'a' opens it for appending 
		#'+' (appended to any of the previous modes) open the file for updating (note that 'w+' truncates the file) 
		#'b' (appended to any of the previous modes) open the file in binary mode 
		#bufsize is 0 for unbuffered, 1 for line-buffered, negative for sys-default, all else, of (about) given size.
    #primerament busquem les secicons "ENTITIES" que hi ha en el fitxer.
    continuar = "Cert"
    while (continuar == "Cert"):
        Llegim_Parell_linies(file)
        index=index+1 #A mesura que anem abanant de linia, incrementem el nostre index.
        if (linea == "ENTITIES"):
##            print "Hem trobat un ENTITIES"
            continuar = "False"
    #Ara anem a processar les seccions "ENTITIES" per buscar "LINES" i "ARC"
    #llegim la segent lnia:
##    print "seguim llegint el fitxer"
    Llegim_Parell_linies(file)
    print linea
    index += 1 #A mesura que anem abanant de linia, incrementem el nostre index.
    #Aqu haurem de fer un bucle infinit fins que no arribssim a final de fitxer
    x=0
    while ((linea!="ENDSEC") and (linea!="EOF")):
##        print "hem entrat dins el bucle ENDSEC & EOF"
        if (linea!="ENDSEC"):
##            print "hem entrat dins el if ENDSEC"
            if (linea == "LINE"): #tractem la LINE que hem trobat
##                print "Hem entrat dins el if LINE"
                processLineEntity(file) #hem de crear aquesta funci
            elif (linea == "ARC"): #tractem el ARC que hem trobat
                processArcEntity(file) #hem de crear aquesta funci per no s com fer els ARCS en blender.
            else:
##                print "hem entrat dins el ELSE LINE"
                Llegim_Parell_linies(file)
                index += 1 #A mesura que anem abanant de linia, incrementem el nostre index.
    #final del bucle infinit (final de fitxer)
    print linea
    #finalment hem de tancar el fitxer DXF
    file.close()
    #Les files que cont la matriu sn corresponents al nmero de vrtex que t la boca.
##    print "Numero de vertex:", Matriu_Boca.fila

    #afegim el centre de la boca
    #Ens retornar els punts Mig de la Boca, que els podrem fer servir desprs per omplir la boca de punts.
    (PuntMigX,PuntMigY)= setBoundingBox(Matriu_Boca)
    
    #Mostrem el contingut de la Matriu que hem creat amb els vrtex de la boca
    Mostrar_Matriu_Boca(Matriu_Boca)
##    print "Numero de vertex:", Matriu_Boca.fila

    # ------------------------------------------------ #
   # --- OMPLIR L'INTERIOR DE LA BOCA AMB VERTEXS---- #


   # -------------------------------------------- #

    # --- ANEM PER A CONNECTAR ELS VRTEXS ENTRE ELLS --- #
    # ---- Ordenem el vrtex ms petit en la primera posici ---- #

        

    FindLowest(Matriu_Boca)
    #Mostrar_Matriu_Boca(Matriu_Boca)
            
    # ----- Preparem per connectar els vrtexs per formar les cares ------ #

    Preparar_Unio_De_Vertex(Matriu_Boca)#Aqu s on ordenem la matriu segons la "Tangent"
    #Mostrar_Matriu_Boca(Matriu_Boca)
    
    
    # ------------------------------------------------------- #
    # ---------- Utilitzem el mtode Graham Scan ------------ #

    Graham_Scan(Matriu_Boca,Matriu_Graham)
   
    #Un cop som aqu tenim la Matriu_Graham que cont el contorn de la boca.
    #Aquesta matriu s interessant que la tinguem ben guardada perqu ens serveix
    #per saber si els punts que volem insertar (nous punts) a la nostra matriu
    #fan intersecci amb el contorn de la boca, s a dir, ens permet saber si
    #aquests es troben dins o fara de la boca.

    #Creem una matriu nova (copia de la Matriu_Graham)
    Matriu_Copiada= Matriu_Nova()

    #Volem que els nostres punts es trobin en el punt (0,0,0)
    Translacio_Matriu(Matriu_Graham)

    Copiar_Matrius(Matriu_Graham, Matriu_Copiada)
    #Ara tinc una copia de la MatriuGraham
    print "Matriu_Graham: "
    Mostrar_Matriu_Boca(Matriu_Graham)
    CrearPuntsInteriors2(Matriu_Copiada)
    #Ara la Matriu_Copiada ja cont els Punts Interiors
    #Per no cont els punts que formen el contorn de la boca
    #La matriu_Graham cont els punts del contorn de la boca
    
    #A la funci Triangulaci li tinc que passar la matriu amb els punts interiors (Matriu_Copiada)
    #i la matriu amb els punts que formen el contorn de la boca (Matriu_Graham)
    Triangulacio(Matriu_Graham, Matriu_Copiada)
      
    maximaY=Ymax(Matriu_Graham)
    minimaY=Ymin(Matriu_Graham)
    maximaX=Xmax(Matriu_Graham)
    minimaX=Xmin(Matriu_Graham)
    print "max Y: ",maximaY
    print "min Y: ",minimaY
    print "max X: ",maximaX
    print "min X: ",minimaX
   # -------------------------------------------- #

   #--- Creem un nou objecte amb el nou "Mesh" -----
    
    objecte = Object.New('Mesh','ObjectePoligon')
    objecte.setLocation(round((minimaX+maximaX)/2,3),round((minimaY+maximaY)/2,3),0)

    #--- Ara pel poligon2 ---#
    
    poligon2.setMode("TwoSided") #Doble cara
    objecte2 = Object.New('Mesh','ObjectePoligon2')
    objecte2.setLocation(round((minimaX+maximaX)/2,3),round((minimaY+maximaY)/2,3),0)

    escena2 = Scene.GetCurrent()
    escena2.link(objecte2)
    objecte2.link(poligon2)
    #Anem per posar el color del mn a negre
    print "Color??"
    Worlds = Blender.World.Get()
    print Worlds
    Worlds[0].hor = [0.,0.,0.]
    Blender.Redraw()
    

#Aquesta funci carrega el fitxer que cont el nostre reflector:
def my_callback(filename):
    print "tria el teu fitxer", filename
    Load_DXF(filename)


def CrearPla(Plan,X,Y,Z):
    #tenim minimaX, minimaY i 0
    #per encara guardem les variables maximaX i maximaY
    print distancia
    print Z
    print Z-distancia.val
    zeta=Z-distancia.val
    print zeta
    vertex = NMesh.Vert(X,Y,Z)
    #Afegim el vertex que hem creat al nostre polgon
    Plan.verts.append(vertex)
    vertex= NMesh.Vert(maximaX, Y, Z)
    Plan.verts.append(vertex)
    vertex=NMesh.Vert(maximaX,maximaY,Z)
    Plan.verts.append(vertex)
    vertex=NMesh.Vert(X,maximaY,Z)
    Plan.verts.append(vertex)
    cara=NMesh.Face()
    #cara.FaceModes['ALL']
    cara.append(Plan.verts[0])
    cara.append(Plan.verts[1])
    cara.append(Plan.verts[2])
    cara.append(Plan.verts[3])
    #cara = NMesh.FaceTranspModes.ALPHA
    Plan.faces.append(cara)
    #PlaObjecte = NMesh.PutRaw(Plan,'Plahoritzontal',1,1)
    ObjectePla = Object.New('Mesh','ObjectePla')
    ObjectePla.link(Plan)
    ObjectePla.setLocation(0,0,0)
    ObjectePla.setLocation(0,0,zeta)
    escena = Scene.GetCurrent()
    escena.link(ObjectePla)
    if ((maximaX-minimaX)>150):
        if ((maximaX-minimaX)>250):
            if ((maximaX-minimaX)>350):
                if ((maximaX-minimaX)>450):
##                    ObjectePla.setSize(round(ObjectePla.SizeX/4,3), round(ObjectePla.SizeY/4,3), zeta)
                    Objecte0=Object.Get('ObjectePoligon2')
                    Objecte0.setSize(round(Objecte0.SizeX/4,3), round(Objecte0.SizeY/4,3), zeta)
                else:
##                    ObjectePla.setSize(round(ObjectePla.SizeX/5,3), round(ObjectePla.SizeY/5,3), zeta)
                    Objecte0=Object.Get('ObjectePoligon2')
                    Objecte0.setSize(round(Objecte0.SizeX/5,3), round(Objecte0.SizeY/5,3), zeta)
            else:
##                ObjectePla.setSize(round(ObjectePla.SizeX/4,3), round(ObjectePla.SizeY/4,3), zeta)
                Objecte0=Object.Get('ObjectePoligon2')
                Objecte0.setSize(round(Objecte0.SizeX/4,3), round(Objecte0.SizeY/4,3), zeta)
        else:
##            ObjectePla.setSize(round(ObjectePla.SizeX/3,3), round(ObjectePla.SizeY/3,3), zeta)
            Objecte0=Object.Get('ObjectePoligon2')
            Objecte0.setSize(round(Objecte0.SizeX/3,3), round(Objecte0.SizeY/3,3), zeta)
    Blender.Redraw()


def CrearPla2(Plan,X,Y,Z):
    zeta=Z-distancia.val
    print 'longitudX: ', maximaX-minimaX
    print 'longitudY: ', maximaY-minimaY

def FerRender():
    global escena, renderitza
    
##--------------------------- prova2
    escena = Scene.GetCurrent()
    #primer de tot hauria de posicionar la cmera a la punta del pla.
    obcamera= Object.Get('Camera')
    part="001"
    x=minimaX
    #Tinc el nmero de imatges que volem que ens treguin a "NImatges.val"
    # Per n'haurem de fer l'arrel quadrada
    print "NImatges: ",NImatges.val
    print "sqrt NImatges: ", sqrt(int(NImatges.val))
    parts=sqrt(int(round(int(NImatges.val))))
    print "parts: ",parts
    longitudx=maximaX-minimaX
    print "longitudx: ",longitudx
    longitudy=maximaY-minimaY
    print "Longitudy: ",longitudy
    divisionsx=int(round(int(longitudx/parts)))
    print "divisionsx: ", divisionsx
    divisionsy=int(round(int(longitudy/parts)))
    print "divisionsy: ", divisionsy
    #En cas de que existeixi el fitxer.txt l'eliminarem
    EliminarArxiu(NomArxiu.val+'.txt')
    EliminarArxiu(NomArxiu.val+'.txt.copia')
    for n in range (0,int(parts)):
        y = minimaY
        mitjax=(x+x+divisionsx)/2

        for m in range (0,int(parts)):
            mitjay=(y+y+divisionsy)/2
            obcamera.setLocation(mitjax,mitjay,obcamera.LocZ)
            context = escena.getRenderingContext()
            Render.EnableDispWin()
            context.extensions = True
            context.imageType = Render.JPEG
            context.renderPath = Directori.val+"/"
            
            filename=NomArxiu.val+part
            print filename
            context.render()
            context.saveRenderedImage(filename,0)
            Render.CloseRenderWindow()
            CrearFitxerText(obcamera.LocX,obcamera.LocY,filename)
            #Convertim el string a integer per poder-li sumar un '1'
            numero=int(part)
            numero=numero+1
            #Convertim el integer a string
            if (numero<10):
                part="00"+str(numero)
            elif (numero<100)and(numero>9):
                part="0"+str(numero)
            else:
                part=str(numero)
            print part
            y=y+divisionsy #Agafo passos de 100 en 100 per fer proves
        x=x+divisionsx
            
    
    print context.fps
    print context.cFrame


def CrearFitxerText(posX,posY,nomfitxer):
    
    path=Directori.val+"/"
    nom_fitxer = NomArxiu.val+'.txt'
    os.chdir(Directori.val)

    
    if not exists(Directori.val):
        #PupStrInput("El directori no existeix o no s vlid !!", "1", 1)
        os.mkdir(Directori.val)
        os.chdir(Directori.val)
        f1 = open(nom_fitxer,'w')
        print "No existeix el directori"
        
    else:

        if not exists(nom_fitxer):
            f1=open(nom_fitxer,'w')
            f1.close()
            print "No existeix el fitxer"
        
        path=Directori.val+"/"
        nom_fitxer = NomArxiu.val+'.txt'
        #Tinc que crear la lnia de la forma "x,y,nomarxiu"
        nova_linia = str(posX)+' '+str(posY)+' '+nomfitxer+'.jpg'+' '
        nom_copia = nom_fitxer + '.copia'
        os.chdir(Directori.val)
        f1 = open(nom_fitxer,'r')
        #Fem una copia
        f2 = open(nom_copia,'w')
        for linia in f1:
            f2.write(linia)
    
        f1 = open(nom_fitxer,'w')
        f2.close()   

        f1.close()

        #i refem l'original afegint la nova linia.
        f1 = open(nom_copia,'r')
        f2 = open(nom_fitxer, 'w')
        for linia in f1:
            f2.write(linia)
        f2.write(nova_linia + '\n')
        f2.close()
        f1.close()

def EliminarArxiu(nomarxiu):
    if exists(Directori.val):
        os.chdir(Directori.val)
        if exists(nomarxiu):
            os.remove(nomarxiu)
        

##################################################
############### BUTONS D'INICI ###################
##################################################
    
#Aquesta funci ens mostra els botons del nostre programa
#A partir que nosaltres haguem seleccionat els botons que ens fan falta ja s'inicialitzar el procs seleccionat
def gui():
    
    global gzipmode
    global outdir, toggle1, toggle2, togglex, toggley, togglez
    global distancia, mymsg, distanciaevt
    global Llumpevt, buto1premut, Cameraevt, Renderevt
    global sortirevt, plaevt, Llumpspotevt, Llumplampevt, Eix_xevt, Eix_yevt, Eixzevt
    global Caixa_Aevt, NomArxiu, Directori, Caixa_Bevt, NImatges, Caixa_Cevt
    
    buto1premut="False"
  
    glRasterPos2i(20, 120)
    Text("Importaci de la Boca del Reflector en format 'dxf' (ESC per sortir): ")
    Button("Importar Arxiu", exportevt, 60, 40, 110, 19)
    #------------#

    Button("Sortir",sortirevt , 20, 10, 80, 18)
    distancia = Slider("Distncia: ", distanciaevt, 200,68, 210, 18,distancia.val, 2, 400.0, 2)
    Button("Crear Pl",Plaevt , 200, 40, 80, 18)
    #-------------#

    Button("Insertar Llump", Llumpevt, 295,40,90,18)
    #-------------#
    Toggle("Lamp", Llumplampevt, 390, 40, 50, 18, toggle1)
    Toggle("Spot", Llumpspotevt, 390, 20, 50, 18, toggle2)
    #-------------#
    Button("Insertar cmera", Cameraevt, 455, 40, 90, 18)
    #-------------#
    #Caixa per insertar el nom de l'arxiu i el directori (Renderitzaci)
    NomArxiu = String("Nom Arxiu: ",Caixa_Aevt,560,60,200,18,"Imatge",20,"Introdueix el nom de l'arxiu a renderitzar")
    Directori = String("Nom Directori: ",Caixa_Bevt,560,80,400,18,"c:/Render",80,"Introdueix directori 'c:/nomdirectori'")
    NImatges = String("NImatges: ",Caixa_Cevt,660,40,100,18,"50",6,"Nmero de 'Renders'")
    #-------------#
    #String("Botostring",Stringevt,590,40,50,18,"1",7)
    Button ("Renderitzaci", Renderevt,560,40,90,18)
    #Butt de proves per crear fitxer de txt.
    #Button ("Fitxer txt", Fitxerevt,660,20,90,18)
    

            
def event(evt, val):
    
    if (evt == ESCKEY and not val): Exit()
     #El but de LAMP estar premut
    

#Rutina que crida el But importar arxiu
def bevent(evt): #Button Event
    global buto1premut #diem que el buto1 s el de importar arxiu
    global Plan, objecte, obj, Llumpspotevt, Llumplampevt, Eix_xevt, Eix_yevt, Eix_zevt
    global toggle1, toggle2, togglex, toggley, togglez, Renderevt, objecte2
    global poligon, poligon2, distancia, Fitxerevt
    
    if (evt ==  exportevt):
        
        Window.FileSelector (my_callback, "Escull un fitxer")
        buto1premut="true"
        Blender.Redraw()

##    if (evt == Llumpevt):
    if (evt == sortirevt): Exit()
    if (evt == Plaevt):
        
        #necessito saber en quina posicio es troba el nostre reflector.
        scene = Scene.getCurrent()
        #objecte0 = Object.Get('ObjectePoligon2')
        Plan=NMesh.New('Superficia')
        #La distancia que li passem a la z s la distncia que hem seleccionat nosaltres a l'slider
        CrearPla(Plan,round(minimaX,3),round(minimaY,3),0)
        #print "objecte boca: ",objecte0.SizeX, objecte0.SizeY
        #print "minimXY: ",minimaX, minimaY
        #CrearPla2(Plan,objecte0.SizeX,objecte0.SizeY,0)
        Redraw()
    if (evt == Llumpevt):
        
        if (toggle2==1):
            scene=Scene.GetCurrent()
            
            l = Lamp.New('Spot')            # create new 'Spot' lamp data
            l.setMode('Shadows','Square')   # set these two lamp mode flags
            l.setDist(50)
            ob = Object.New('Lamp')         # create new lamp object
            ob.link(l)                      # link lamp obj with lamp data
            scene.link(ob)
            scene.makeCurrent()
        elif (toggle1==1):
            scene=Scene.GetCurrent()
            l = Lamp.New('Lamp')            # create new 'Spot' lamp data
            l.setMode('Shadows','Square')   # set these two lamp mode flags
            l.setDist(50)
            ob = Object.New('Lamp')         # create new lamp object
            ob.link(l)                      # link lamp obj with lamp data
            
            scene.link(ob)
            scene.makeCurrent()


        Blender.Redraw()
    #Pels butons "toggle" que trien el tipus de llump
    if (evt == Llumpspotevt):
        toggle2 = 1 - toggle2
        toggle1 = 0
        Blender.Redraw()

    if (evt == Llumplampevt):
        toggle1 = 1 - toggle1
        toggle2 = 0
        Blender.Redraw()

    #Pel but que tria la cmera
    if (evt == Cameraevt):
        BocaReflector= Object.Get('ObjectePoligon2')
        print BocaReflector
        BocaReflector.getLocation()
        print BocaReflector.LocX
        print BocaReflector.LocY
        print BocaReflector.LocZ
        print BocaReflector.loc

             
        #Un cop tenim guardat el nmero de cmeres ja podem crear les cmeres
        c = Camera.New('ortho')     # create new ortho camera data
        c.setMode("showLimits","showMist")
        c.scale = 80.0               # set scale value
        c.setDrawSize(80)
        c.setClipEnd(200)
        cur = Scene.getCurrent()    # get current scene
        ob = Object.New('Camera')   # make camera object
        ob.link(c)                  # link camera data with this object
        
        #Hem enllaat l'objecte amb la cmera i per tant ara tenim un objecte que cont una cmera.
        #Ara anem a fer que aquesta cmera apunti a la nostra boca tota l'estona
        #Per fer aix haurem d'afegir un Constraint

        ob.constraints.append(Constraint.Type.TRACKTO)
        const = ob.constraints
        #Amb aquestes dues lnies anteriors hem insertat la propietat TRACKTO a la nostra cmera
        c = const[0]
        print c.type
        print c.name
        c[Constraint.Settings.TARGET]=objecte2
        c[Constraint.Settings.TRACK]=Constraint.Settings.TRACKNEGZ
        c[Constraint.Settings.UP]=Constraint.Settings.UPY
        #Ara Hauria de posicionar la cmera        
        #Busquem el centre del pl
        centre_Y=round((minimaY+maximaY)/2,3)
        centre_X=round((minimaX+maximaX)/2,3)
        Plan=Object.Get('ObjectePla')
        ZPlan=Plan.LocZ
        print "La Z del Pla: ",ZPlan
        ob.setLocation(centre_X,centre_Y,ZPlan+2)   #si no toquem la distancia la cmera se'ns posiciona al 0,0,0
        cur.link(ob)                # link object into scene
        cur.setCurrentCamera(ob)    # make this camera the active"        
        
        Blender.Redraw()

    #Butons que restringeixen els eixos
    if (evt == Eix_xevt):
        togglex = 1 - togglex
        toggley = 0
        togglez = 0
        Blender.Redraw()
    if (evt == Eix_yevt):
        toggley = 1 - toggley
        togglex = 0
        togglez = 0
        Blender.Redraw()
    if (evt == Eix_zevt):
        togglez = 1 - togglez
        togglex = 0
        toggley = 0
        Blender.Redraw()
    if (evt == Renderevt):
        FerRender()
    if (evt == Fitxerevt):
        CrearFitxerText('23','12','jordi')
        
#################################################
############# PROGRAMA PRINCIPAL ################
#################################################

global poligon #s l'objecte del nostre reflector.
global cara #sn les cares del nostre reflector.
global poligon2
global cara2
global Llumpevt, Llumpspotevt, Llumplampevt, toggle1, toggle2
global sortirevt, Plaevt, Cameraevt, Renderevt, Caixa_Bevt, Caixa_Aevt, Caixa_Cevt, Fitxerevt

#parmetres del llump
distancia= Create (1.0)
tipusllump = Create(1)
mymsg="TEXT"
#events
exportevt = 1 #Aquesta variable la utilitzem per fer la crida als butons
Llumpevt = 2
sortirevt = 3
Plaevt = 4
distanciaevt=5
Llumpspotevt=6
Llumplampevt=7
Cameraevt=8
Eix_xevt=9
Eix_yevt=10
Eix_zevt=11
distanciaevt=12
Renderevt=13
Caixa_Aevt=14
Caixa_Bevt=15
Caixa_Cevt=16
Fitxerevt=17
toggle1=1 #Un llump ha d'estar activat
toggle2=0
togglex=1
toggley=0
togglez=0

poligon = NMesh.New()
poligon2 = NMesh.New()

#Fem una crida al nostre panell de treball (botons)
Register(gui, event, bevent)

print "Redibuixem sobre Blender"
# ---- Dibuixem o actualitzem la escena del Blender ---
Blender.Redraw()

