function plot2DValues(image)


count=length(image);
x=zeros(1,count);
y=zeros(1,count);
z=zeros(1,count);
for i=1:count,
   x(1,i)=image(i).coord(1);
   y(1,i)=image(i).coord(2);
   z(1,i)=image(i).imgVal;
end;
disp(x);
disp(y);
disp(z);
minx = min(x); maxx=max(x);
miny = min(y); maxy=max(y);
intx = minx:(maxx-minx)/100:maxx;
inty = miny:(maxy-miny)/100:maxy;
[XI,YI] = meshgrid(intx, inty);
ZI=griddata(x,y,z,XI,YI);
meshc(XI,YI,ZI), hold
contour(x, y, z);
