function [A,count]=readImagesAndCoordinates(index)

indexFile = sprintf('%s%s', index, 'Imatge.txt');
disp(indexFile);

fid = fopen(indexFile, 'r');
format = '%g %g %s\r';
[names, count] = fscanf(fid,format);
fclose(fid);

realCount = count / 3; %'cause we've "final" 4 columns
rowSize = length(names)/realCount;
sizeName = length(names)/realCount - 2; %the size of the filename

for i=1:realCount,
    row = names((i-1)*rowSize+1:i*rowSize)';
    imgName = sprintf('%s%s', index, strcat(char(row(3:(2+sizeName)))));
    disp(imgName); disp(row(1:2));
    temp = rgb2gray(imread(imgName)); % ./ 255;
    A(i).imgVal = sum(temp(:)) / 255;
    A(i).coord = row(1:2);
    
end;
count=realCount;
